﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using csLTDMC;


namespace 初始化
{
    public partial class Form1 : Form
    {
        private ushort _CardNo = 7;
        private ushort[] axis = new ushort[32];
        private bool m_bInit = false;
        private bool m_sevEnable = false;
        public Form1()
        {
            InitializeComponent();
        }
        
        private void button_connect_Click(object sender, EventArgs e)
        {
            button_connect.Enabled = false;
            short res = 0;
            ushort err = 0;
            uint totalAxis = 0;
            ushort cardnum = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short num = LTDMC.dmc_board_init();
            if (num <= 0 || num > 8)
            {
                Output("初始卡失败!");
                button_connect.Enabled = true;
                return;
            }
            res = LTDMC.dmc_get_CardInfList(ref cardnum, cardtypes, cardids);//获取控制卡信息
            if (res != 0)
            {
                Output("获取卡信息失败!");
                button_connect.Enabled = true;
                return;
            }
            bool EtherCardFlag = false;
            for (ushort i = 0; i < cardnum; i++)
            {
                int _cardtype = (int)cardtypes[i];
                _cardtype = _cardtype & 0xfffff;
                if (_cardtype == 0x15032 || _cardtype == 0x13032)  //查找第一张E35032或E3032卡
                {
                    numericUpDown_cardNo.Value = new decimal(cardids[i]);
                    _CardNo = cardids[i];
                    EtherCardFlag = true;
                    break;
                }
            }
            if (!EtherCardFlag)
            {
                Output("不存在EtherCAT总线卡!");
                button_connect.Enabled = true;
                return;
            }
            res = LTDMC.nmc_get_errcode(_CardNo, 2, ref err);//获取总线状态
            if (res == 0)
            {
                if (err != 0)//总线报错
                {
                    DateTime dt_start = DateTime.Now;
                    res = LTDMC.dmc_soft_reset(_CardNo);//复位总线错误
                    if (res != 0)
                    {
                        Output("dmc_soft_reset == " + res.ToString());
                        button_connect.Enabled = true;
                        return;
                    }
                    Output("总线复位中... ");
                    while (true)
                    {
                        if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//超时退出循环
                        {
                            Output("总线复位失败！");
                            button_connect.Enabled = true;
                            return;
                        }
                        res = LTDMC.nmc_get_errcode(_CardNo, 2, ref err);
                        if (res == 0)
                        {
                            if (err == 0)//总线复位正常完成
                            {
                                break;
                            }
                        }
                        else
                        {
                            Output("nmc_get_errcode == " + res.ToString());
                            button_connect.Enabled = true;
                            return;
                        }
                        Application.DoEvents();
                    }
                }
            }

            res = LTDMC.nmc_get_total_axes(_CardNo, ref totalAxis);
            if (res != 0)
            {
                Output("nmc_get_total_axes == " + res.ToString());
                button_connect.Enabled = true;
                return;
            }
            if (totalAxis <= 0)
            {
                Output("控制卡未连接从站或未通过motion扫描下载从站配置信息");
                button_connect.Enabled = true;
                return;
            }
            comboBox_axis.Items.Clear();
            for (ushort i = 0; i < totalAxis; i++)
            {
                comboBox_axis.Items.Add(String.Format("{0:d}-Axis", i));
                axis[i] = i;
            }
            comboBox_axis.SelectedIndex = 0;
            res = LTDMC.dmc_download_configfile(_CardNo, "AxisPara.ini");//下载轴参数文件
            if (res != 0)
            {
                Output("dmc_download_configfile == " + res.ToString());
            }
            GetAxisParam();//界面参数刷新
            m_bInit = true;
            Output("初始化卡成功！");
            timer1.Start();
        }
        private void button_disconnect_Click(object sender, EventArgs e)
        {
            if (m_bInit == true)
            {
                timer1.Stop();
                short res = LTDMC.dmc_board_close();
                m_bInit = false;
                button_connect.Enabled = true;
            }
            
        }
        private void button_enable_Click(object sender, EventArgs e)
        {
            if (m_bInit != true)
            {
                Output("使能前请初始化控制卡！");
                return;
            }
            short res = 0;
            if (m_sevEnable)
            {
                res = LTDMC.nmc_set_axis_disable(_CardNo, axis[comboBox_axis.SelectedIndex]);// 失能对应轴
                if (res != 0)
                {
                    Output("nmc_set_axis_disable == " + res.ToString());
                    return;
                }

            }
            else
            {
                res = LTDMC.nmc_set_axis_enable(_CardNo, axis[comboBox_axis.SelectedIndex]);// 使能对应轴
                if (res != 0)
                {
                    Output("nmc_set_axis_enable == " + res.ToString());
                    return;
                }
            }            
        }
        private ushort GetMoveMode()
        {
            ushort MoveMode = 0;
            if (radioButton_rel.Checked)
            {
                MoveMode = 0;
            }
            else
            {
                MoveMode = 1;
            }
            return MoveMode;
        }
             
        private void timer1_Tick(object sender, EventArgs e)
        {
            double speed =0;
            ushort axs = axis[comboBox_axis.SelectedIndex];
            LTDMC.dmc_read_current_speed_unit(_CardNo, axs, ref speed);
            textBox_vel.Text = speed.ToString();
            //
            double pos = 0;
            LTDMC.dmc_get_position_unit(_CardNo, axs, ref pos);
            textBox_cmdPos.Text = pos.ToString();
            LTDMC.dmc_get_encoder_unit(_CardNo, axs, ref pos);
            textBox_encPos.Text = pos.ToString();
            //
            ushort Axis_State_machine = 0;
            LTDMC.nmc_get_axis_state_machine(_CardNo, axs, ref Axis_State_machine);
            switch (Axis_State_machine)// 读取指定轴状态机
            {
                case 0: textBox_axisState.Text = "轴处于未启动状态";
                    textBox_axisState.BackColor = Color.Red;
                    break;
                case 1:
                    textBox_axisState.Text = "轴处于启动禁止状态";
                    textBox_axisState.BackColor = Color.Red;
                    break;
                case 2:
                    textBox_axisState.Text = "轴处于准备启动状态";
                    textBox_axisState.BackColor = Color.Red;
                    break;
                case 3:
                    textBox_axisState.Text = "轴处于启动状态";
                    textBox_axisState.BackColor = Color.Red;
                    break;
                case 4:
                    textBox_axisState.Text = "轴处于操作使能状态";
                    textBox_axisState.BackColor = Color.Green;                 
                    break;
                case 5:
                    textBox_axisState.Text = "轴处于停止状态";
                    textBox_axisState.BackColor = Color.Red;
                    break;
                case 6:
                    textBox_axisState.Text = "轴处于错误触发状态";
                    textBox_axisState.BackColor = Color.Red;
                    break;
                case 7:
                    textBox_axisState.Text = "轴处于错误状态";
                    textBox_axisState.BackColor = Color.Red;
                    break;                
            };
            if (Axis_State_machine == 4)
            {
                button_enable.Text = "失能";
                m_sevEnable = true;
            }
            else
            {
                button_enable.Text = "使能";
                m_sevEnable = false;
            }
            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardNo, 2, ref errcode);
            if (errcode == 0)
            {
                textBox_ecState.Text = "EtherCAT总线正常";
                textBox_ecState.BackColor = Color.Green;
            }
            else
            {
                textBox_ecState.Text = "EtherCAT总线出错";
                textBox_ecState.BackColor = Color.Red;
            }
            //
            short xs = LTDMC.dmc_check_done(_CardNo, axs);
            if (xs == 1)
            {
                textBox_currentState.Text = "停止";
            }
            else
            {
                textBox_currentState.Text = "运行";
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (m_bInit)
            {
                timer1.Stop();
                LTDMC.dmc_board_close();
            }
        }
        private void GetAxisParam()
        {
            short res = 0;
            double s = 0;
            double start = 0;
            double speed = 0;
            double acc = 0;
            double dec = 0;
            double stop = 0;
            double time = 0;

            res = LTDMC.dmc_get_s_profile(_CardNo, axis[comboBox_axis.SelectedIndex], 0, ref s);//设置S段时间（0-1s)
            if (res != 0)
            {
                Output("smc_get_s_profile == " + res.ToString());
                return;
            }
            numericUpDown_spara.Value = new decimal(s);
            res = LTDMC.dmc_get_profile_unit(_CardNo, axis[comboBox_axis.SelectedIndex], ref start, ref speed, ref acc, ref dec, ref stop);//设置起始速度、运行速度、停止速度、加速时间、减速时间
            if (res != 0)
            {
                Output("smc_get_profile_unit == " + res.ToString());
                return;
            }
            numericUpDown_startVel.Value = new decimal(start);
            numericUpDown_vel.Value = new decimal(speed);
            numericUpDown_acc.Value = new decimal(acc);
            numericUpDown_dec.Value = new decimal(dec);
            numericUpDown_stopVel.Value = new decimal(stop);
            res = LTDMC.dmc_get_dec_stop_time(_CardNo, axis[comboBox_axis.SelectedIndex], ref time);
            if (res != 0)
            {
                Output("dmc_get_dec_stop_time == " + res.ToString());
                return;
            }
        }
        private void button_setGet_Click(object sender, EventArgs e)
        {
            short res = 0;
            double start = decimal.ToDouble(numericUpDown_startVel.Value);
            double speed = decimal.ToDouble(numericUpDown_vel.Value);
            double stop = decimal.ToDouble(numericUpDown_stopVel.Value);
            double acc = decimal.ToDouble(numericUpDown_acc.Value);
            double dec = decimal.ToDouble(numericUpDown_dec.Value);
            double s = decimal.ToDouble(numericUpDown_spara.Value);
            //ushort State_Machine = 0;
            if (m_bInit)
            {
                //res = LTDMC.nmc_get_axis_state_machine(_CardNo, axis[comboBox_axis.SelectedIndex], ref State_Machine);
                //if (State_Machine == 4)
                {
                    res = LTDMC.dmc_set_s_profile(_CardNo, axis[comboBox_axis.SelectedIndex], 0, s);//设置S段时间（0-1s)
                    if (res != 0)
                    {
                        Output("dmc_set_s_profile == " + res.ToString());
                        return;
                    }
                    res = LTDMC.dmc_set_profile_unit(_CardNo, axis[comboBox_axis.SelectedIndex], start, speed, acc, dec, stop);//设置起始速度、运行速度、停止速度、加速时间、减速时间
                    if (res != 0)
                    {
                        Output("dmc_set_profile_unit == " + res.ToString());
                        return;
                    }
                    res = LTDMC.dmc_set_dec_stop_time(_CardNo, axis[comboBox_axis.SelectedIndex], dec);
                    if (res != 0)
                    {
                        Output("dmc_set_dec_stop_time == " + res.ToString());
                        return;
                    }
                    GetAxisParam();
                }
            }
        }

        private void button_start_Click(object sender, EventArgs e)
        {
            short res = 0;
            ushort movemode = GetMoveMode();
            double dist = decimal.ToDouble(numericUpDown_movePos.Value);
            if (m_bInit)//初始化成功
            {
                if (m_sevEnable)//轴使能
                {
                    res = LTDMC.dmc_pmove_unit(_CardNo, axis[comboBox_axis.SelectedIndex], dist, movemode);
                    if (res != 0)
                    {
                        Output("dmc_pmove_unit == " + res.ToString());
                    }
                }
            }
        }
        private void button_stop_Click(object sender, EventArgs e)
        {
            short res = 0;
            if (m_bInit)
            {
                res = LTDMC.dmc_stop(_CardNo, axis[comboBox_axis.SelectedIndex], 0);
                if (res != 0)
                {
                    Output("dmc_stop == " + res.ToString());
                    return;
                }
            }
        }
        private void button_emg_Click(object sender, EventArgs e)
        {
            short res = 0;
            if (m_bInit)
            {
                //紧急停止所有轴
                res = LTDMC.dmc_emg_stop(_CardNo);
                if (res != 0)
                {
                    Output("dmc_emg_stop == " + res.ToString());
                    return;
                }
            }
        }

        private void button_clearPos_Click(object sender, EventArgs e)
        {
            if (m_bInit)
            {
                short res = LTDMC.dmc_set_position_unit(_CardNo, axis[comboBox_axis.SelectedIndex], 0);//位置清零
                if (res != 0)
                {
                    Output("dmc_set_position_unit == " + res.ToString());
                }
            }
        }

        private void button_errClear_Click(object sender, EventArgs e)
        {
            if (m_bInit)
            {
                short res = LTDMC.nmc_clear_axis_errcode(_CardNo, axis[comboBox_axis.SelectedIndex]);//清除轴错误
                if (res != 0)
                {
                    Output("nmc_clear_axis_errcode == " + res.ToString());
                }
            }
        }

        private void button_ecClearErr_Click(object sender, EventArgs e)
        {
            if (m_bInit)
            {
                short res = LTDMC.nmc_clear_errcode(_CardNo, 2);//清除总线错误
                if (res != 0)
                {
                    Output("nmc_clear_errcode == " + res.ToString());
                }
            }
        }

        private void button_left_MouseDown(object sender, MouseEventArgs e)
        {
            short res = 0;
            if (m_bInit)
            {
                if (m_sevEnable)//轴使能
                {
                    res = LTDMC.dmc_vmove(_CardNo, axis[comboBox_axis.SelectedIndex], 0);//负方向运动
                    if (res != 0)
                    {
                        Output("dmc_vmove == " + res.ToString());
                    }
                }
            }
        }

        private void button_left_MouseUp(object sender, MouseEventArgs e)
        {
            short res = 0;
            if (m_bInit)
            {
                res = LTDMC.dmc_stop(_CardNo, axis[comboBox_axis.SelectedIndex], 0);// 减速停止
                if (res != 0)
                {
                    Output("dmc_stop == " + res.ToString());
                }
            }
        }

        private void button_right_MouseDown(object sender, MouseEventArgs e)
        {

            short res = 0;
            if (m_bInit)
            {
                if (m_sevEnable)//轴使能
                {
                    res = LTDMC.dmc_vmove(_CardNo, axis[comboBox_axis.SelectedIndex], 1);//正方向运动
                    if (res != 0)
                    {
                        Output("dmc_vmove == " + res.ToString());
                    }
                }
            }
        }

        private void button_right_MouseUp(object sender, MouseEventArgs e)
        {
            short res = 0;
            if (m_bInit)
            {
                res = LTDMC.dmc_stop(_CardNo, axis[comboBox_axis.SelectedIndex], 0);// 减速停止
                if (res != 0)
                {
                    Output("dmc_stop == " + res.ToString());
                }
            }
        }
        private void Output(string msg)
        {
            string txt = string.Format("{0}:{1}\r\n", DateTime.Now.ToString("HH:mm:ss"), msg);
            try
            {
                this.Invoke(
                    (MethodInvoker)delegate
                    {
                        textBox_msg.AppendText(txt);
                    }
                    );
            }
            catch (Exception)
            {
            }
        }
        
        private void 清空ToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            textBox_msg.Clear();
        }
    }
}
