﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using csLTDMC;
using System.Threading;
using System.Drawing.Drawing2D;

namespace TestP2P
{
    public partial class Form1 : Form
    {
        private ushort _CardID = 0;
        private ushort i = 0;
        ushort axis = 0;            //关联轴号
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short num = LTDMC.dmc_board_init();//获取卡数量
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
            }
          
            ushort _num = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short res = LTDMC.dmc_get_CardInfList(ref _num, cardtypes, cardids);
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
            }

            _CardID = cardids[0];            

            timer1.Start();          
          
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            ushort Axis_State_machine0 = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, axis, ref Axis_State_machine0);
            switch (Axis_State_machine0)// 读取指定轴状态机
            {
                case 0: textBox5.Text = "轴处于未启动状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 1:
                    textBox5.Text = "轴处于启动禁止状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 2:
                    textBox5.Text = "轴处于准备启动状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 3:
                    textBox5.Text = "轴处于启动状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 4:
                    textBox5.Text = "轴处于操作使能状态";
                    textBox5.BackColor = Color.Green;
                    break;
                case 5:
                    textBox5.Text = "轴处于停止状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 6:
                    textBox5.Text = "轴处于错误触发状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 7:
                    textBox5.Text = "轴处于错误状态";
                    textBox5.BackColor = Color.Red;
                    break;
            };            

            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardID, 2, ref errcode);
            if (errcode == 0)
            {
                textBox6.Text = "EtherCAT总线正常";
                textBox6.BackColor = Color.Green;
            }
            else
            {
                textBox6.Text = "EtherCAT总线出错";
                textBox6.BackColor = Color.Red;
            }
            
            double ZSpeed = 0;
            LTDMC.dmc_read_current_speed_unit(_CardID, axis, ref ZSpeed);
            XActVel.Text = ZSpeed.ToString();   
         
            double ZPos = 0;
            LTDMC.dmc_get_position_unit(_CardID, axis, ref ZPos);
            XActPos.Text = ZPos.ToString();

            int Number = 0;
            LTDMC.dmc_ltc_get_number(_CardID, 0, 0, ref Number);
            textBox1.Text = Number.ToString();

            double Latch_Pos = 0;
            LTDMC.dmc_ltc_get_value_unit(_CardID, 0, 0, ref Latch_Pos);
            textBox4.Text = Latch_Pos.ToString();

            int remained_points = 0, runed_point = 0;
            double current_point = 0;
            LTDMC.dmc_hcmp_get_current_state_unit(_CardID, 0, ref remained_points, ref current_point, ref runed_point);
            textBox2.Text = current_point.ToString();//返回当前比较点位置
            textBox3.Text = runed_point.ToString();//返回已比较点数
        }     
  
        private void ZeroPos_Click(object sender, EventArgs e)
        {
            LTDMC.dmc_stop(_CardID, axis, 1);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //位置清零,为了方便测试高速比较功能
            LTDMC.dmc_set_position_unit(_CardID, axis, 0);

            ushort hcmp_0 = 0;          //比较器号
            ushort cmp_mode_0 = 5;      // 比较模式，5线性
            ushort cmp_source=1;          //比较位置源，固定值 1：辅助编码器计数器
            ushort cmp_logic=0;          //有效电平： 0：低电平， 1：高电平
            int time = 100000;       //脉冲宽度，单位： us，取值范围： 1us~20s
            double cmp_pos=10000;          //添加比较位置
            double increment = 10000;  //设置高速比较线性模式参数，位置增量值
            int count = 4;          //设置高速比较线性模式参数，比较次数

            short res = LTDMC.dmc_hcmp_set_mode(_CardID, hcmp_0, cmp_mode_0);//配置比较器0  比较模式

            res = LTDMC.dmc_hcmp_set_config(_CardID, hcmp_0, 0, cmp_source, cmp_logic, time);//配置比较器0，比较源为辅助编码器0

            res = LTDMC.dmc_hcmp_add_point_unit(_CardID, hcmp_0, cmp_pos);//配置比较器0  添加比较点位置

            res = LTDMC.dmc_hcmp_set_liner_unit(_CardID, hcmp_0, increment, count);//配置比较器0  设置线性比较参数
        }

        private void button2_Click(object sender, EventArgs e)
        {
            LTDMC.dmc_hcmp_clear_points(_CardID, 0);//清除已添加的所有高速位置比较点
            LTDMC.dmc_set_extra_encoder(_CardID, 0, 0);//清除辅助编码器0的值
        }

        private void ContiStart_Click_1(object sender, EventArgs e)
        {
            //位置清零
            LTDMC.dmc_set_position_unit(_CardID, axis, 0);
            LTDMC.dmc_set_profile_unit(_CardID, axis, 0, 5000, 0.1, 0.1, 0);
            short res = LTDMC.dmc_pmove_unit(_CardID, axis, 60000, 1);
            if(res != 0)
            {
                MessageBox.Show("dmc_pmove_unit == " + res.ToString());
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            ushort latch_0 = 0;//锁存器0            
            ushort latch_source = 1; //  锁存源，1：辅助编码器计数器
            ushort latch_mode = 0;  //  触发模式 0：单次锁存，1：连续锁存
            ushort latch_logic = 1; //  触发方式 0：下降沿锁存，1：上升沿锁存
            double filter = 100;//滤波时间

            LTDMC.dmc_ltc_reset(_CardID, latch_0);     //复位锁存器0

            LTDMC.dmc_ltc_set_mode(_CardID, latch_0, latch_mode, latch_logic, filter);  //配置锁存器0，锁存模式为单次锁存，上升沿锁存 

            LTDMC.dmc_ltc_set_source(_CardID, latch_0, 0, latch_source); //配置锁存器0，锁存源为辅助编码器计数器 0      

        }

        private void button3_Click(object sender, EventArgs e)
        {
            ushort latch_0 = 0;//锁存器0            
            LTDMC.dmc_ltc_reset(_CardID, latch_0);     //复位锁存器0 
        }      

        private void button8_Click(object sender, EventArgs e)
        {
            LTDMC.nmc_set_axis_enable(_CardID, axis);// 使能对应轴            
        }

        private void button9_Click(object sender, EventArgs e)
        {
            LTDMC.nmc_set_axis_disable(_CardID, axis);// 失能对应轴            
        }

        private void button10_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……" + "\n");
            button10.Enabled = false;
            button11.Enabled = false;
            //Application.DoEvents();
            LTDMC.dmc_board_reset();
            LTDMC.dmc_board_close();

            for (int i = 0; i < 15; i++)//总线卡硬件复位耗时15s左右
            {
                Application.DoEvents();
                Thread.Sleep(1000);
            }

            LTDMC.dmc_board_init();
            richTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button10.Focus();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡软件复位进行中……" + "\n");
            button11.Enabled = false;
            button10.Enabled = false;
            DateTime dt_start = DateTime.Now;
            short res = LTDMC.dmc_soft_reset(_CardID);
            if (res != 0)
            {
                MessageBox.Show("dmc_soft_reset == " + res.ToString());
                return;
            }
            ushort err = 0;
            while (true)
            {
                if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//设置超时退出，防止死循环
                {
                    MessageBox.Show("总线复位失败!");
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                res = LTDMC.nmc_get_errcode(_CardID, 2, ref err);
                if (res == 0)
                {
                    if (err == 0)//总线复位正常完成
                    {
                        break;
                    }
                }
                else
                {
                    MessageBox.Show("nmc_get_errcode == " + res.ToString());
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                Application.DoEvents();
            }
            richTextBox1.AppendText("总线卡软件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button11.Focus();
        }
    }
}
