﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using csLTDMC;
using System.Threading;

namespace 连续运动
{
    public partial class Form1 : Form
    {
        private ushort _CardID = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short num = LTDMC.dmc_board_init();//获取卡数量
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
            }
            ushort _num = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short res = LTDMC.dmc_get_CardInfList(ref _num, cardtypes, cardids);
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
            }
            _CardID = cardids[0];
            //
            timer1.Start();
        }

        private ushort GetAxis()
        {
            return decimal.ToUInt16(numericUpDown1.Value);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            double dEquiv; //脉冲当量
            double dStartVel;//起始速度
            double dMaxVel;//运行速度
            double dTacc;//加速时间
            double dTdec;//减速时间
            double dStopVel;//停止速度
            double dS_para;//S段时间
            ushort sDir; //运动方向，0：负方向，1：正方向
            ushort State_Machine = 0;//获取轴状态机

            dEquiv = decimal.ToDouble(numericUpDown2.Value);
            dStartVel = decimal.ToDouble(numericUpDown3.Value);
            dMaxVel = decimal.ToDouble(numericUpDown4.Value);
            dTacc = decimal.ToDouble(numericUpDown5.Value);
            dTdec = decimal.ToDouble(numericUpDown6.Value);
            dStopVel = decimal.ToDouble(numericUpDown8.Value);
            dS_para = decimal.ToDouble(numericUpDown7.Value);
            short res = 0;
            if (radioButton8.Checked)
            {
              sDir = 1; //正向
            }
            else 
            {
              sDir = 0;//负向
            }
            res = LTDMC.dmc_set_profile_unit(_CardID, axis, dStartVel, dMaxVel, dTacc, dTdec, dStopVel);//设置速度参数
            res = LTDMC.dmc_set_s_profile(_CardID, axis, 0, dS_para);//设置S段速度参数
            res = LTDMC.dmc_set_dec_stop_time(_CardID, axis, dTdec); //设置减速停止时间
            res = LTDMC.dmc_vmove(_CardID, axis, sDir);//连续运动
            if (res != 0)
            {
                MessageBox.Show("dmc_vmove == " + res.ToString());
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            double dNewVel;// 新的运行速度
            double dTaccDec;//变速时间

            dNewVel = decimal.ToDouble(numericUpDown10.Value);
            dTaccDec = decimal.ToDouble(numericUpDown11.Value);

            short res = LTDMC.dmc_change_speed_unit(_CardID, axis, dNewVel, dTaccDec); //在线变速
            if (res != 0)
            {
                MessageBox.Show("dmc_change_speed_unit == " + res.ToString());
            }

        }

        private void button4_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            ushort stop_mode = 0; //制动方式，0：减速停止，1：紧急停止

            LTDMC.dmc_stop(_CardID, axis, stop_mode);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            double dpos = 0;// 当前位置

            LTDMC.dmc_set_position_unit(_CardID, axis, dpos); //设置指定轴的当前指令位置值
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            double dEquiv; //脉冲当量
            dEquiv = decimal.ToDouble(numericUpDown2.Value);

            short res = LTDMC.dmc_set_equiv(_CardID, axis, dEquiv);  
            if (res != 0)
            {
                MessageBox.Show("dmc_set_equiv == " + res.ToString());
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Stop();
            LTDMC.dmc_board_close();//控制卡关闭函数，释放系统资源
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            double dcurrent_speed = 0;//速度值
            double dunitPos = 0; //指令值
            double encPos = 0; //反馈值
            ushort Axis_State_machine = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, axis, ref Axis_State_machine);
            switch (Axis_State_machine)// 读取指定轴状态机
            {
                case 0: textBox5.Text = "NOT_READY_SWITCH_ON";
                    textBox5.BackColor = Color.Red;
                    break;
                case 1:
                    textBox5.Text = "SWITCH_ON_DISABLE";
                    textBox5.BackColor = Color.Red;
                    break;
                case 2:
                    textBox5.Text = "READY_TO_DISABLE";
                    textBox5.BackColor = Color.Red;
                    break;
                case 3:
                    textBox5.Text = "SWOTCH_ON";
                    textBox5.BackColor = Color.Red;
                    break;
                case 4:
                    textBox5.Text = "OP_ENABLE";
                    textBox5.BackColor = Color.Green;
                    break;
                case 5:
                    textBox5.Text = "QUICK_STOP";
                    textBox5.BackColor = Color.Red;
                    break;
                case 6:
                    textBox5.Text = "FAULT_ACTIVE";
                    textBox5.BackColor = Color.Red;
                    break;
                case 7:
                    textBox5.Text = "FAULT";
                    textBox5.BackColor = Color.Red;
                    break;
            };

            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardID, 2, ref errcode);
            if (errcode == 0)
            {
                textBox6.Text = "EtherCAT总线正常";
                textBox6.BackColor = Color.Green;
            }
            else
            {
                textBox6.Text = "EtherCAT总线出错";
                textBox6.BackColor = Color.Red;
            }
            LTDMC.dmc_read_current_speed_unit(_CardID, axis, ref dcurrent_speed); // 读取轴当前速度
            textBox1.Text = dcurrent_speed.ToString();
            LTDMC.dmc_get_position_unit(_CardID, axis, ref dunitPos); //读取指定轴指令位置值
            textBox2.Text = dunitPos.ToString();
            LTDMC.dmc_get_encoder_unit(_CardID, axis, ref encPos);//读取指定轴反馈位置值
            textBox3.Text = encPos.ToString();

            if (LTDMC.dmc_check_done(_CardID, axis) == 0) // 读取指定轴运动状态
            {
                textBox4.Text = "运行中";
                textBox4.BackColor = Color.Green;
            }
            else
            {
                textBox4.Text = "停止中";
                textBox4.BackColor = Color.Red;
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            short res = 0;
            //ushort State_Machine = 0;
            //short res = LTDMC.nmc_get_axis_state_machine(_CardID, axis, ref State_Machine);
            //if (res != 0)
            //{
            //    MessageBox.Show("nmc_get_axis_state_machine == " + res.ToString());
            //    return;
            //}
            //if (State_Machine == 0 || State_Machine == 6 || State_Machine == 7)
            //{
            //    MessageBox.Show("轴状态机不正常，不能操作");
            //    return;
            //}
            res = LTDMC.nmc_set_axis_enable(_CardID, axis);// 使能对应轴
            if (res != 0)
            {
                MessageBox.Show("nmc_set_axis_enable == " + res.ToString());
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            short res = 0;

            res = LTDMC.nmc_set_axis_disable(_CardID, axis);// 失能对应轴
            if (res != 0)
            {
                MessageBox.Show("nmc_set_axis_disable == " + res.ToString());
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……" + "\n");
            button10.Enabled = false;
            button11.Enabled = false;
            //Application.DoEvents();
            LTDMC.dmc_board_reset();
            LTDMC.dmc_board_close();

            for (int i = 0; i < 15; i++)//总线卡硬件复位耗时15s左右
            {
                Application.DoEvents();
                Thread.Sleep(1000);
            }

            LTDMC.dmc_board_init();
            richTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button10.Focus();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡软件复位进行中……" + "\n");
            button11.Enabled = false;
            button10.Enabled = false;
            DateTime dt_start = DateTime.Now;
            short res = LTDMC.dmc_soft_reset(_CardID);
            if (res != 0)
            {
                MessageBox.Show("dmc_soft_reset == " + res.ToString());
                return;
            }
            ushort err = 0;
            while (true)
            {
                if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//设置超时退出，防止死循环
                {
                    MessageBox.Show("总线复位失败!");
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                res = LTDMC.nmc_get_errcode(_CardID, 2, ref err);
                if (res == 0)
                {
                    if (err == 0)//总线复位正常完成
                    {
                        break;
                    }
                }
                else
                {
                    MessageBox.Show("nmc_get_errcode == " + res.ToString());
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                Application.DoEvents();
            }
            richTextBox1.AppendText("总线卡软件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button11.Focus();
        }

        private void button12_Click(object sender, EventArgs e)
        {
            short res = LTDMC.nmc_clear_errcode(_CardID, 2);//清除总线错误
            if (res != 0)
            {
                MessageBox.Show("nmc_clear_errcode == " + res.ToString());
            }
        }

        private void button13_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            short res = LTDMC.nmc_clear_axis_errcode(_CardID, axis);//清除轴错误
            if (res != 0)
            {
                MessageBox.Show("nmc_clear_axis_errcode == " + res.ToString());
            }
        }
      
    }
}
