﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using csLTDMC;
using System.Threading;
using System.Drawing.Drawing2D;

namespace TestP2P
{
    public partial class Form1 : Form
    {
        private ushort _CardID = 0;
        double Min_Vel = 0, Max_Vel = 3000, Tacc = 0.1, Tdec = 0.1, Stop_Vel = 0;
        ushort Mode = 1; //运动模式，0：相对坐标模式，1：绝对坐标模式
        ushort AxisX = 0, AxisY = 1, AxisZ = 2, crd = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short num = LTDMC.dmc_board_init();//获取卡数量
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
            }
          
            ushort _num = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short res = LTDMC.dmc_get_CardInfList(ref _num, cardtypes, cardids);
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
            }
            _CardID = cardids[0];
            
            timer1.Start();
            DrawPosImage();
          
        }

        private List<double> _PointsX = new List<double>();
        private List<double> _PointsY = new List<double>();
        private List<double> _PointsZ = new List<double>();

        private void DrawPosImage()
        {
            int width = pictureBox1.Width;
            int height = pictureBox1.Height;
            //
            Bitmap bm = new Bitmap(width, height);
            //
            Graphics g = Graphics.FromImage(bm);
            Matrix matrix = new Matrix(1, 0, 0, -1, 0, height);
            g.Transform = matrix;
            g.SmoothingMode = SmoothingMode.AntiAlias;
            //网格绘制
            Pen pen = new Pen(Color.Green);
            g.DrawLine(pen, new Point(width / 3, height / 2), new Point(0, height / 2 - width / 3));
            g.DrawLine(pen, new Point(width / 3, height / 2), new Point(width, height / 2));
            g.DrawLine(pen, new Point(width / 3, height / 2), new Point(width / 3, height));
            //
            SolidBrush brush = new SolidBrush(Color.Black);
            g.ResetTransform();
            g.DrawString("0", this.Font, brush, width / 3 - 15, height / 2 - 15);

            g.Transform = matrix;
            //
      

            //轨迹绘制
            pen = new Pen(Color.Black);
            
            for (int i = 0; i < _PointsX.Count - 1; i++)
            {
                PointF p1 = ToPointF(_PointsX[i], _PointsY[i], _PointsZ[i]);
                PointF p2 = ToPointF(_PointsX[i + 1], _PointsY[i + 1], _PointsZ[i + 1]);
                g.DrawLine(pen, p1, p2);
            }

            g.Dispose();          
            //
            pictureBox1.Image = bm;
        }
 

        private PointF ToPointF(double x, double y, double z)
        {
            int width = pictureBox1.Width;
            int height = pictureBox1.Height;
            //
            double _x = y - x * Math.Cos(Math.PI / 4);
            double _y = z - x * Math.Cos(Math.PI / 4);
            //
            double n = 1000 / 60;
            _x = _x / n + width / 3;
            _y = _y / n + height / 2;
            //
            return new PointF((float)_x, (float)_y);
        }
       
          
        private void timer1_Tick(object sender, EventArgs e)
        {
            double XSpeed = 0;
            LTDMC.dmc_read_current_speed_unit(_CardID, AxisX, ref XSpeed); 
            XActVel.Text = XSpeed.ToString();
            double YSpeed = 0;
            LTDMC.dmc_read_current_speed_unit(_CardID, AxisY, ref YSpeed);
            YActVel.Text = YSpeed.ToString();
            double ZSpeed = 0;
            LTDMC.dmc_read_current_speed_unit(_CardID, AxisZ, ref ZSpeed);
            ZActVel.Text = ZSpeed.ToString();

            ushort Axis_State_machine0 = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, AxisX, ref Axis_State_machine0);
            switch (Axis_State_machine0)// 读取指定轴状态机
            {
                case 0: textBox5.Text = "轴处于未启动状态";
                        textBox5.BackColor = Color.Red;
                    break;
                case 1:
                        textBox5.Text = "轴处于启动禁止状态";
                        textBox5.BackColor = Color.Red;
                    break;
                case 2:
                        textBox5.Text = "轴处于准备启动状态";
                        textBox5.BackColor = Color.Red;
                    break;
                case 3:
                        textBox5.Text = "轴处于启动状态";
                        textBox5.BackColor = Color.Red;
                    break;
                case 4:
                        textBox5.Text = "轴处于操作使能状态";
                        textBox5.BackColor = Color.Green;
                    break;
                case 5:
                        textBox5.Text = "轴处于停止状态";
                        textBox5.BackColor = Color.Red;
                    break;
                case 6:
                        textBox5.Text = "轴处于错误触发状态";
                        textBox5.BackColor = Color.Red;
                    break;
                case 7:
                        textBox5.Text = "轴处于错误状态";
                        textBox5.BackColor = Color.Red;
                    break;
            };

            ushort Axis_State_machine1 = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, AxisY, ref Axis_State_machine1);
            switch (Axis_State_machine1)// 读取指定轴状态机
            {
                case 0: textBox1.Text = "轴处于未启动状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 1:
                    textBox1.Text = "轴处于启动禁止状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 2:
                    textBox1.Text = "轴处于准备启动状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 3:
                    textBox1.Text = "轴处于启动状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 4:
                    textBox1.Text = "轴处于操作使能状态";
                    textBox1.BackColor = Color.Green;
                    break;
                case 5:
                    textBox1.Text = "轴处于停止状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 6:
                    textBox1.Text = "轴处于错误触发状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 7:
                    textBox1.Text = "轴处于错误状态";
                    textBox1.BackColor = Color.Red;
                    break;
            };

            ushort Axis_State_machine2 = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, AxisZ, ref Axis_State_machine2);
            switch (Axis_State_machine2)// 读取指定轴状态机
            {
                case 0: textBox2.Text = "轴处于未启动状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 1:
                    textBox2.Text = "轴处于启动禁止状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 2:
                    textBox2.Text = "轴处于准备启动状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 3:
                    textBox2.Text = "轴处于启动状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 4:
                    textBox2.Text = "轴处于操作使能状态";
                    textBox2.BackColor = Color.Green;
                    break;
                case 5:
                    textBox2.Text = "轴处于停止状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 6:
                    textBox2.Text = "轴处于错误触发状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 7:
                    textBox2.Text = "轴处于错误状态";
                    textBox2.BackColor = Color.Red;
                    break;
            };

            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardID, 2, ref errcode);
            if (errcode == 0)
            {
                textBox6.Text = "EtherCAT总线正常";
                textBox6.BackColor = Color.Green;
            }
            else
            {
                textBox6.Text = "EtherCAT总线出错";
                textBox6.BackColor = Color.Red;
            }                   

            double XPos = 0;
            LTDMC.dmc_get_position_unit(_CardID, AxisX, ref XPos);
            XActPos.Text = XPos.ToString();
            double YPos = 0;
            LTDMC.dmc_get_position_unit(_CardID, AxisY, ref YPos);
            YActPos.Text = YPos.ToString();
            double ZPos = 0;
            LTDMC.dmc_get_position_unit(_CardID, AxisZ, ref ZPos);
            ZActPos.Text = ZPos.ToString();

            switch (LTDMC.dmc_conti_get_run_state(_CardID, crd))
            {
                case 0:
                    CrdStatus.Text = "运动中";
                    CrdStatus.BackColor = Color.Green;
                    break;
                case 1:
                    CrdStatus.Text = "暂停中";
                    CrdStatus.BackColor = Color.Red;
                    break;
                case 2:
                    CrdStatus.Text = "正常停止";
                    CrdStatus.BackColor = Color.Red;
                    break;
                case 3:
                    CrdStatus.Text = "未启动";
                    CrdStatus.BackColor = Color.Red;
                    break;
                case 4:
                    CrdStatus.Text = "空闲";
                    CrdStatus.BackColor = Color.Red;
                    break;
            }
            // 绘制轨迹
            if (_PointsX.Count > 0)
            {
                if (_PointsX[_PointsX.Count - 1] != XPos || _PointsY[_PointsY.Count - 1] != YPos || _PointsZ[_PointsZ.Count - 1] != ZPos)
                {
                    _PointsX.Add(XPos);
                    _PointsY.Add(YPos);
                    _PointsZ.Add(ZPos);
                    DrawPosImage();
                }
            }
            else
            {
                _PointsX.Add(XPos);
                _PointsY.Add(YPos);
                _PointsZ.Add(ZPos);
            }
               
        }

        private void button7_Click(object sender, EventArgs e)
        {            

            Min_Vel = decimal.ToUInt16(numericUpDown5.Value); //获取最小速度
            Max_Vel = decimal.ToUInt16(numericUpDown6.Value);//获取最大速度
            Tacc = decimal.ToUInt16(numericUpDown7.Value);//获取加速时间
            Tdec = decimal.ToUInt16(numericUpDown8.Value);//获取减速时间
            Stop_Vel = decimal.ToUInt16(numericUpDown9.Value);//获取停止速度

            short res = 0;

            //设置插补速度曲线     
            res = LTDMC.dmc_set_vector_profile_unit(_CardID, crd, Min_Vel, Max_Vel, Tacc, Tdec, Stop_Vel);
            if (res != 0)
            {
                MessageBox.Show("dmc_set_vector_profile_unit == " + res.ToString());
            }

        }

    

        private void button1_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 2; //插补轴数     

            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, -1200);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);
            
            short res = LTDMC.dmc_arc_move_center_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY }, new double[] { 500, 500 }, new double[] { 0, 800 }, 0, 2, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString());
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            _PointsX.Clear();
            _PointsY.Clear();
            _PointsZ.Clear();
            DrawPosImage();

            ushort Max_axis = 2;
            for (ushort axis = 0; axis <= Max_axis; axis++)
            {
                LTDMC.dmc_set_position(_CardID, axis, 0);//位置清零
            }

        }

        private void button3_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 2; //插补轴数
            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);
       
            short res = LTDMC.dmc_line_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY },new double[] { 10000, 10000 }, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_line_unit == " + res.ToString());
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 3; //插补轴数
            ushort AxisX = 0, AxisY = 1, AxisZ = 2, crd = 0;

            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);        

            short res = LTDMC.dmc_line_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY, AxisZ },new double[] { 10000, 10000, 10000 }, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_line_unit == " + res.ToString());
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 2; //插补轴数

            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);
     
            short res = LTDMC.dmc_arc_move_center_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY }, new double[] { 0, 3000 }, new double[] { 0, 1500 }, 1, 0, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString());
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 2; //插补轴数

            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);
       
            short res = LTDMC.dmc_arc_move_center_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY }, new double[] { 0, 3000 }, new double[] { 0, 800 }, 1, 3, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString());
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {            
            ushort AxisNum = 3; //插补轴数

            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);

            short res = LTDMC.dmc_arc_move_center_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY,AxisZ }, new double[] { 0, 3000,3000 }, new double[] { 0, 800,0 }, 1, 3, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString());
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 3; //插补轴数

            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, -1200);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);

            short res = LTDMC.dmc_arc_move_center_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY, AxisZ }, new double[] { 500,500, 3000 }, new double[] { 0, 800, 0 }, 1, 3, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString());
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 3; //插补轴数

            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);

            short res = LTDMC.dmc_arc_move_center_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY, AxisZ }, new double[] { 0, 3000, 2000 }, new double[] { 0, 1500, 0 }, 1, 3, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString());
            }
        }

      

        private void button12_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 2; //插补轴数
            ushort Radius ; //插补半径

            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);

            Radius = 1500;
            short res = LTDMC.dmc_arc_move_radius_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY }, new double[] { 0, 3000 }, Radius, 1, 0, Mode);//
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_radius_unit == " + res.ToString());
            }
        }

        private void button13_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 3; //插补轴数
            ushort Radius; //插补半径

            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);

            Radius = 1500;
            short res = LTDMC.dmc_arc_move_radius_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY, AxisZ }, new double[] { 0, 3000, 2000 }, Radius, 1, 3, Mode);//
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_radius_unit == " + res.ToString());
            }
        }

        private void button14_Click(object sender, EventArgs e)
        {
            ushort AxisX = 0, AxisY = 1, AxisZ = 2, crd = 0;

            ushort AxisNum = 3; //插补轴数
            int cricle = -1;//设置空间圆弧，圆弧圈数为0
            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);

            short res = LTDMC.dmc_arc_move_3points_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY, AxisZ }, new double[] { 3000, 3000, 0 }, new double[] { 1500, 1500, 1500 }, cricle, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_3points_unit == " + res.ToString());
            }
        }

        private void button15_Click(object sender, EventArgs e)
        {
            ushort AxisNum = 3; //插补轴数
            int cricle = 3;//设置空间圆弧，圆弧圈数为3
            //例程为了方便观察曲线，设置特定的起始位置，实际项目中不需要调用dmc_set_position_unit
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisZ, 0);

            short res = LTDMC.dmc_arc_move_3points_unit(_CardID, crd, AxisNum, new ushort[] { AxisX, AxisY, AxisZ }, new double[] { 0, 3000, 2000 }, new double[] { 1000, 1000, 1000 }, cricle, Mode);
            if (res != 0)
            {
                MessageBox.Show("dmc_arc_move_3points_unit == " + res.ToString());
            }
        }


        private void button11_Click(object sender, EventArgs e)
        {
            LTDMC.nmc_set_axis_enable(_CardID, 0);// 使能对应轴
            LTDMC.nmc_set_axis_enable(_CardID, 1);// 使能对应轴
            LTDMC.nmc_set_axis_enable(_CardID, 2);// 使能对应轴
        }

        private void button16_Click(object sender, EventArgs e)
        {
            LTDMC.nmc_set_axis_disable(_CardID, 0);// 失能对应轴
            LTDMC.nmc_set_axis_disable(_CardID, 1);// 失能对应轴
            LTDMC.nmc_set_axis_disable(_CardID, 2);// 失能对应轴
        }

        private void button19_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button17_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……" + "\n");
            button17.Enabled = false;
            button18.Enabled = false;
            //Application.DoEvents();
            LTDMC.dmc_board_reset();
            LTDMC.dmc_board_close();

            for (int i = 0; i < 15; i++)//总线卡硬件复位耗时15s左右
            {
                Application.DoEvents();
                Thread.Sleep(1000);
            }

            LTDMC.dmc_board_init();
            richTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态");
            button17.Enabled = true;
            button18.Enabled = true;
            button17.Focus();
        }

        private void button18_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡软件复位进行中……" + "\n");
            button17.Enabled = false;
            button18.Enabled = false;
            //Application.DoEvents();
            DateTime dt_start = DateTime.Now;
            short res = LTDMC.dmc_soft_reset(_CardID);
            if (res != 0)
            {
                MessageBox.Show("dmc_soft_reset == " + res.ToString());
                return;
            }
            ushort err = 0;
            while (true)
            {
                if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//设置超时退出，防止死循环
                {
                    MessageBox.Show("总线复位失败!");
                    button17.Enabled = true;
                    button18.Enabled = true;
                    button18.Focus();
                    return;
                }
                res = LTDMC.nmc_get_errcode(_CardID, 2, ref err);
                if (res == 0)
                {
                    if (err == 0)//总线复位正常完成
                    {
                        break;
                    }
                }
                else
                {
                    MessageBox.Show("nmc_get_errcode == " + res.ToString());
                    button17.Enabled = true;
                    button18.Enabled = true;
                    button18.Focus();
                    return;
                }
                Application.DoEvents();
            }
            richTextBox1.AppendText("总线卡软件复位完成,请确认总线状态");
            button17.Enabled = true;
            button18.Enabled = true;
            button18.Focus();
        }

    }
}
