﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using csLTDMC;
using System.Drawing.Drawing2D;

namespace 连续插补运动_脉冲当量_
{
    public partial class Form1 : Form
    {
        private ushort _CardID = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short num = LTDMC.dmc_board_init();//获取卡数量
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
            }
            ushort _num = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short res = LTDMC.dmc_get_CardInfList(ref _num, cardtypes, cardids);
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
                return;
            }
            _CardID = cardids[0];
            //
            ushort AxisX = GetAxisX();
            ushort AxisY = GetAxisY();
            ushort crd = GetCrd();
            //设置脉冲当量
            res = LTDMC.dmc_set_equiv(_CardID, AxisX, decimal.ToDouble(numericUpDown3.Value));
            res = LTDMC.dmc_set_equiv(_CardID, AxisY, decimal.ToDouble(numericUpDown5.Value));
            if (res != 0)
            {
                MessageBox.Show("设置脉冲当量失败!");
                return;
            }
               //
            timer1.Start();
            DrawPosImage();
        }
        private ushort GetAxisX()
        {
            return decimal.ToUInt16(numericUpDown2.Value);
        }
        private ushort GetAxisY()
        {
            return decimal.ToUInt16(numericUpDown4.Value);
        }
        private ushort GetCrd()
        {
            return decimal.ToUInt16(numericUpDown1.Value);
        }
        private List<PointF> _Points = new List<PointF>();
        private DateTime _StartTime = DateTime.Now;
        private List<PointF> _VTPoints = new List<PointF>();
        private void DrawVTImage()
        {
            int width = pictureBox2.Width;
            int height = pictureBox2.Height;
            //
            Bitmap bm = new Bitmap(width, height);
            //
            Graphics g = Graphics.FromImage(bm);
            Matrix matrix = new Matrix(1, 0, 0, -1, 0, height);
            g.Transform = matrix;
            g.SmoothingMode = SmoothingMode.AntiAlias;
            //网格绘制
            Pen pen = new Pen(Color.Black);
            g.DrawLine(pen, new Point(0, 20), new Point(width, 20));
            g.DrawLine(pen, new Point(20, 0), new Point(20, height));
            //
            SolidBrush brush = new SolidBrush(Color.Black);
            g.ResetTransform();
            g.DrawString("0", this.Font, brush, 5, height - 15);
            g.Transform = matrix;
            //
            pen = new Pen(Color.Green);
            pen.DashPattern = new float[] { 3f, 5f };
            int n = (int)((width - 20) / 30);
            for (int i = 0; i < n; i++)
            {
                int _x = (i + 1) * 30 + 20;
                g.DrawLine(pen, new Point(_x, 20), new Point(_x, height));
                //
                g.ResetTransform();
                string txt = (i + 1).ToString();
                g.DrawString(txt, this.Font, brush, _x - 5, height - 15);
                g.Transform = matrix;
            }
            n = (int)((height - 20) / 30);
            for (int i = 0; i < n; i++)
            {
                int _y = (i + 1) * 30 + 20;
                g.DrawLine(pen, new Point(20, _y), new Point(width, _y));
                //
                g.ResetTransform();
                string txt = ((i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, 25, height - _y - 5);
                g.Transform = matrix;
            }

            //轨迹绘制
            pen = new Pen(Color.Red);
            float nx = 1f / 30f;
            float ny = 2000f / 30f;
            for (int i = 0; i < _VTPoints.Count; i++)
            {
                if (i > 0)
                {
                    g.DrawLine(pen, new PointF(_VTPoints[i].X / nx + 20, _VTPoints[i].Y / ny + 20), new PointF(_VTPoints[i - 1].X / nx + 20, _VTPoints[i - 1].Y / ny + 20));
                }
            }
            g.Dispose();
            //
            pictureBox2.Image = bm;
        }

        private void DrawPosImage()
        {
            int width = pictureBox1.Width;
            int height = pictureBox1.Height;
            //
            Bitmap bm = new Bitmap(width, height);
            //
            Graphics g = Graphics.FromImage(bm);
            Matrix matrix = new Matrix(1, 0, 0, -1, 0, height);
            g.Transform = matrix;
            g.SmoothingMode = SmoothingMode.AntiAlias;
            //网格绘制
            Pen pen = new Pen(Color.Black);
            g.DrawLine(pen, new Point(0, height / 3), new Point(width, height / 3));
            g.DrawLine(pen, new Point(width / 2, 0), new Point(width / 2, height));
            //
            SolidBrush brush = new SolidBrush(Color.Black);
            g.ResetTransform();
            g.DrawString("0", this.Font, brush, width / 2 + 5, height * 2 / 3 + 5);
            g.Transform = matrix;
            //
            pen = new Pen(Color.Green);
            pen.DashPattern = new float[] { 3f, 5f };
            int n = (int)((width / 2) / 80);
            for (int i = 0; i < n; i++)
            {
                int _x = (i + 1) * 80 + width / 2;
                g.DrawLine(pen, new Point(_x, 0), new Point(_x, height));
                //
                g.ResetTransform();
                string txt = ((i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, _x - 15, height * 2 / 3 + 5);
                g.Transform = matrix;
            }
            for (int i = 0; i < n; i++)
            {
                int _x = width / 2 - (i + 1) * 80;
                g.DrawLine(pen, new Point(_x, 0), new Point(_x, height));
                //
                g.ResetTransform();
                string txt = (-(i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, _x - 20, height * 2 / 3 + 5);
                g.Transform = matrix;
            }
            n = (int)((height * 2 / 3) / 80);
            for (int i = 0; i < n; i++)
            {
                int _y = (i + 1) * 80 + height / 3;
                g.DrawLine(pen, new Point(0, _y), new Point(width, _y));
                //
                g.ResetTransform();
                string txt = ((i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, width / 2 + 5, height - _y - 5);
                g.Transform = matrix;
            }
            n = (int)((height / 3) / 80);
            for (int i = 0; i < n; i++)
            {
                int _y = height / 3 - (i + 1) * 80;
                g.DrawLine(pen, new Point(0, _y), new Point(width, _y));
                //
                g.ResetTransform();
                string txt = (-(i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, width / 2 + 5, height - _y - 5);
                g.Transform = matrix;
            }
            //轨迹绘制
            pen = new Pen(Color.Red);
            float nx = 2000f / 80f;
            float ny = 2000f / 80f;
            for (int i = 0; i < _Points.Count; i++)
            {
                if (i > 0)
                {
                    g.DrawLine(pen, new PointF(_Points[i].X / nx + width / 2, _Points[i].Y / ny + height / 3), new PointF(_Points[i - 1].X / nx + width / 2, _Points[i - 1].Y / ny + height / 3));
                }
            }
            //
            DrawMarkPoint(g, -3000, 3000, "A");
            DrawMarkPoint(g, 1000, 6000, "B");
            DrawMarkPoint(g, 2000, 6000, "C");
            DrawMarkPoint(g, 3000, 6000, "D");
            DrawMarkPoint(g, 4000, 0, "E");


            g.Dispose();
            //
            pictureBox1.Image = bm;
        }
        private void DrawMarkPoint(Graphics g, double x, double y, string txt)
        {
            int width = pictureBox1.Width;
            int height = pictureBox1.Height;
            float nx = 2000f / 80f;
            float ny = 2000f / 80f;
            float _x = (float)(x / nx + width / 2);
            float _y = (float)(y / ny + height / 3);
            g.FillEllipse(new SolidBrush(Color.Blue), new RectangleF(_x - 2f, _y - 2f, 4f, 4f));
            //
            Matrix matrix = g.Transform;
            g.ResetTransform();
            g.DrawString(txt, this.Font, new SolidBrush(Color.Blue), _x, height - _y);
            g.Transform = matrix;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //
            ushort AxisX = GetAxisX();
            ushort AxisY = GetAxisY();
            ushort crd = GetCrd();
            short res = 0;
            //设置脉冲当量
            //LTDMC.dmc_set_equiv(_CardID, AxisX, decimal.ToDouble(numericUpDown3.Value));
            //LTDMC.dmc_set_equiv(_CardID, AxisY, decimal.ToDouble(numericUpDown5.Value));
            //位置清零
            LTDMC.dmc_set_position_unit(_CardID, AxisX, 0);
            LTDMC.dmc_set_position_unit(_CardID, AxisY, 0);
            //   画图
            _Points.Clear();
            DrawPosImage();
            _StartTime = DateTime.Now;
            _VTPoints.Clear();
            DrawVTImage();

            //
            bool cleario = radioButton1.Checked;
            //
            ushort axisnum = 2;
            ushort[] axises = new ushort[] { AxisX, AxisY };
            res = LTDMC.dmc_conti_open_list(_CardID, crd, axisnum, axises);
            //设置插补速度           
            res = LTDMC.dmc_set_vector_profile_unit(_CardID, crd, 0, decimal.ToDouble(numericUpDown8.Value), decimal.ToDouble(numericUpDown9.Value), decimal.ToDouble(numericUpDown9.Value), 0);
            //
            res = LTDMC.dmc_conti_set_pause_output(_CardID, crd, 3, 0x20, 0);//设置暂停连续插补时，OUT5输出低电平，恢复运行时OUT5电平恢复暂停前的电平状态
            // ******************第一段轨迹，半圆弧*********************
            res = LTDMC.dmc_conti_delay_outbit_to_start(_CardID, crd, 0, 0, 3000 * Math.PI / 2, 1, 2);//相对轨迹起点滞后距离输出，OUT0输出低电平，输出后的电平延时翻转时间为2s

            res = LTDMC.dmc_conti_write_outbit(_CardID, crd, 5, 1, 0);//OUT5立即输出高电平
            res = LTDMC.dmc_conti_arc_move_3points_unit(_CardID, crd, axisnum, axises, new double[] { 0, 6000 }, new double[] { -3000, 3000 }, 0, 0, 0);
            if (cleario)
            {
                res = LTDMC.dmc_conti_clear_io_action(_CardID, crd, 0x1);//清除段内 OUT0 未执行完的动作
            }
            //'******************第二段轨迹，直线插补*********************'
            res = LTDMC.dmc_conti_delay_outbit_to_start(_CardID, crd, 3, 0, 1000, 1, 4); //相对轨迹起点滞后距离输出，OUT3输出低电平，输出后的电平延时翻转时间为4s
            res = LTDMC.dmc_conti_delay_outbit_to_start(_CardID, crd, 1, 0, 2000, 1, 4);//相对轨迹起点滞后距离输出，OUT1输出低电平，输出后的电平延时翻转时间为4s
            res = LTDMC.dmc_conti_ahead_outbit_to_stop(_CardID, crd, 2, 0, 1000, 1, 0.5); //相对轨迹终点提前距离输出，OUT2输出低电平，输出后的电平延时翻转时间为0.5s


            res = LTDMC.dmc_conti_line_unit(_CardID, crd, axisnum, axises, new double[] { 4000, 0 }, 0, 0);  //直线插补，相对模式
            if (cleario)
            {
                res = LTDMC.dmc_conti_clear_io_action(_CardID, crd, 0xE);  //清除段内 OUT1,OUT2,OUT3 未执行完的动作，&H表示十六进制
            }
            //******************第三段轨迹，半圆弧*********************'
            res = LTDMC.dmc_conti_arc_move_center_unit(_CardID, crd, axisnum, axises, new double[] { 0, -6000 }, new double[] { 0, -3000 }, 0, 0, 0, 0);   //XY平面圆弧插补，顺时针，相对坐标模式。   此函数是基于圆心圆弧扩展的螺旋线插补运动（可作两轴圆弧插补）

            res = LTDMC.dmc_conti_write_outbit(_CardID, crd, 4, 0, 2);//OUT4立即输出低电平，输出后的电平延时翻转时间为2s

            //******************第四段轨迹，直线插补*********************'
            res = LTDMC.dmc_conti_line_unit(_CardID, crd, axisnum, axises, new double[] { -4000, 0 }, 0, 0);   //直线插补，相对模式

            res = LTDMC.dmc_conti_start_list(_CardID, crd);
            res = LTDMC.dmc_conti_close_list(_CardID, crd);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (LTDMC.dmc_conti_get_run_state(_CardID, GetCrd()) == 0)
            {

                LTDMC.dmc_conti_pause_list(_CardID, GetCrd());
                button2.Text = "继续插补";
            }
            else if (LTDMC.dmc_conti_get_run_state(_CardID, GetCrd()) == 1)
            {
                LTDMC.dmc_conti_start_list(_CardID, GetCrd());
                //LTDMC.dmc_conti_pause_list(_CardID, GetCrd());
                button2.Text = "暂停插补";
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            LTDMC.dmc_conti_stop_list(_CardID, GetCrd(), 1);
            button2.Text = "暂停插补";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            double upx = 0;
            LTDMC.dmc_get_position_unit(_CardID, GetAxisX(), ref upx);
            textBox1.Text = upx.ToString();
            double upy = 0;
            LTDMC.dmc_get_position_unit(_CardID, GetAxisY(), ref upy);
            textBox2.Text = upy.ToString();
            //
            if (_Points.Count > 0)
            {
                if (_Points[_Points.Count - 1].X != upx || _Points[_Points.Count - 1].X != upy)
                {
                    _Points.Add(new PointF((float)upx, (float)upy));
                    DrawPosImage();
                }
            }
            else
            {
                _Points.Add(new PointF((float)upx, (float)upy));
            }


            double sp = 0;
            LTDMC.dmc_read_current_speed_unit(_CardID, GetAxisX(), ref sp);
            _VTPoints.Add(new PointF((float)((DateTime.Now - _StartTime).TotalSeconds), (float)sp));
            DrawVTImage();
            textBox4.Text = sp.ToString();

            if (LTDMC.dmc_conti_check_done(_CardID, GetCrd()) == 0)
            {
                textBox5.Text = "运动中";
            }
            else
            {
                textBox5.Text = "空闲中";
            }
            switch (LTDMC.dmc_conti_get_run_state(_CardID, GetCrd()))
            {
                case 0:
                    textBox6.Text = "运动中";
                    break;
                case 1:
                    textBox6.Text = "暂停中";
                    break;
                case 2:
                    textBox6.Text = "正常停止";
                    break;
                case 3:
                    textBox6.Text = "未启动";
                    break;
                case 4:
                    textBox6.Text = "空闲";
                    break;
            }
            textBox7.Text = LTDMC.dmc_conti_remain_space(_CardID, GetCrd()).ToString();
            textBox8.Text = LTDMC.dmc_conti_read_current_mark(_CardID, GetCrd()).ToString();

            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardID, 2, ref errcode);
            if (errcode == 0)
            {
                textBox3.Text = "EtherCAT总线正常";
                textBox3.BackColor = Color.Green;
            }
            else
            {
                textBox3.Text = "EtherCAT总线出错";
                textBox3.BackColor = Color.Red;
            }
            //
            
            for (int i = 0; i <= 5; i++)
            {
                Panel panel = null;
                foreach (Control control in groupBox4.Controls)
                {
                    if (control is Panel && control.Tag.ToString() == i.ToString())
                    {
                        panel = control as Panel;
                        break;
                    }
                }
                if (panel != null)
                {
                    if (LTDMC.dmc_read_outbit(_CardID, (ushort)i) == 0)
                    {
                        panel.BackColor = Color.Green;
                    }
                    else
                    {
                        panel.BackColor = Color.Red;
                    }
                }
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            short res = 0;
            res = LTDMC.nmc_set_axis_enable(_CardID, 255);// 使能全部轴
            if (res != 0)
            {
                MessageBox.Show("nmc_set_axis_enable == " + res.ToString());
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            short res = 0;
            res = LTDMC.nmc_set_axis_disable(_CardID, 255);// 失能全部轴
            if (res != 0)
            {
                MessageBox.Show("nmc_set_axis_disable == " + res.ToString());
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            button7.Enabled = false;
            DateTime dt_start = DateTime.Now;
            short res = LTDMC.dmc_soft_reset(_CardID);
            if (res != 0)
            {
                MessageBox.Show("dmc_soft_reset == " + res.ToString());
                return;
            }
            ushort err = 0;
            while (true)
            {
                if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//设置超时退出，防止死循环
                {
                    MessageBox.Show("总线复位失败!");
                    button7.Enabled = true;
                    button7.Focus();
                    return;
                }
                res = LTDMC.nmc_get_errcode(_CardID, 2, ref err);
                if (res == 0)
                {
                    if (err == 0)//总线复位正常完成
                    {
                        break;
                    }
                }
                else
                {
                    MessageBox.Show("nmc_get_errcode == " + res.ToString());
                    button7.Enabled = true;
                    button7.Focus();
                    return;
                }
                Application.DoEvents();
            }
            MessageBox.Show("总线卡软件复位完成,请确认总线状态");
            button7.Enabled = true;
            button7.Focus();
        }
    }
}
