﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using csLTDMC;
using System.Drawing.Drawing2D;
using System.Threading;

namespace PVT运动
{
    public partial class Form1 : Form
    {
        private ushort _CardID = 0;
        private int[] _PosX = null;
        private int[] _PosY = null;
        private int[] _PosZ = null;
        private double[] _Time = null;
        private double[] _SpeedX = null;
        private double[] _SpeedY = null;
        private double[] _SpeedZ = null;

        public Form1()
        {
            InitializeComponent();
            //
            int count = 11;
            _PosX = new int[count];
            _PosY = new int[count];
            _PosZ = new int[count];
            _Time = new double[count];
            _SpeedX = new double[count];
            _SpeedY = new double[count];
            _SpeedZ = new double[count];
            //
            double r = 15000;
            for (int i = 0; i < count; i++)
            {
                _PosX[i] = (int)(r * Math.Cos(Math.PI / 6) * Math.Cos((10 - i) * Math.PI / 10) + r * Math.Cos(Math.PI / 6));
                _PosY[i] = (int)(r * Math.Sin(Math.PI / 6) * Math.Cos((10 - i) * Math.PI / 10) + r * Math.Sin(Math.PI / 6));
                _PosZ[i] = (int)(r * Math.Sin((10 - i) * Math.PI / 10));
            }
            for (int i = 0; i < count; i++)
            {
                _Time[i] = i;
            }
            double vel = -Math.PI / 10;
            for (int i = 1; i < count - 1; i++)
            {
                _SpeedX[i] = -r * Math.Cos(Math.PI / 6) * Math.Sin((10 - i) * Math.PI / 10) * vel;
                _SpeedY[i] = -r * Math.Sin(Math.PI / 6) * Math.Sin((10 - i) * Math.PI / 10) * vel;
                _SpeedZ[i] = r * Math.Cos((10 - i) * Math.PI / 10) * vel;

            }
            _SpeedX[0] = 0;
            _SpeedY[0] = 0;
            _SpeedZ[0] = 0;
            _SpeedX[count - 1] = 0;
            _SpeedY[count - 1] = 0;
            _SpeedZ[count - 1] = 0;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short num = LTDMC.dmc_board_init();//获取卡数量
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
            }
            ushort _num = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short res = LTDMC.dmc_get_CardInfList(ref _num, cardtypes, cardids);
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
            }
            _CardID = cardids[0];
            //
            timer1.Start();
            //
            RefreshText();
            //
            DrawVTImage();
            DrawPTImage();
            DrawPosImage();
        }
        private void RefreshText()
        {
            StringBuilder sb = new StringBuilder();
            bool pvt = radioButton1.Checked;
            if (pvt)
            {
                label12.Visible = true;
            }
            else
            {
                label12.Visible = false;
            }
            if (radioButton3.Checked)
            {
                for (int i = 0; i < _PosX.Length; i++)
                {
                    sb.AppendFormat(" {0}\t", i + 1);
                    sb.AppendFormat(" {0}\t\t", _PosX[i]);
                    sb.AppendFormat(" {0}\t", _Time[i]);
                    if (pvt)
                    {
                        sb.AppendFormat(" {0}\t\t", _SpeedX[i]);
                    }
                    sb.AppendLine();
                }
            }
            else if (radioButton4.Checked)
            {
                for (int i = 0; i < _PosY.Length; i++)
                {
                    sb.AppendFormat(" {0}\t", i + 1);
                    sb.AppendFormat(" {0}\t\t", _PosY[i]);
                    sb.AppendFormat(" {0}\t", _Time[i]);
                    if (pvt)
                    {
                        sb.AppendFormat(" {0}\t\t", _SpeedY[i]);
                    }
                    sb.AppendLine();
                }
            }
            else if (radioButton5.Checked)
            {
                for (int i = 0; i < _PosZ.Length; i++)
                {
                    sb.AppendFormat(" {0}\t", i + 1);
                    sb.AppendFormat(" {0}\t\t", _PosZ[i]);
                    sb.AppendFormat(" {0}\t", _Time[i]);
                    if (pvt)
                    {
                        sb.AppendFormat(" {0}\t\t", _SpeedZ[i]);
                    }
                    sb.AppendLine();
                }
            }
            textBox5.Text = sb.ToString();
        }
        private DateTime _StartTime = DateTime.Now;
        private List<PointF> _VTPointsX = new List<PointF>();
        private List<PointF> _PTPointsX = new List<PointF>();
        private List<PointF> _VTPointsY = new List<PointF>();
        private List<PointF> _PTPointsY = new List<PointF>();
        private List<PointF> _VTPointsZ = new List<PointF>();
        private List<PointF> _PTPointsZ = new List<PointF>();
        private List<double> _PointsX = new List<double>();
        private List<double> _PointsY = new List<double>();
        private List<double> _PointsZ = new List<double>();
        private void DrawVTImage()
        {
            int width = pictureBox1.Width;
            int height = pictureBox1.Height;
            //
            Bitmap bm = new Bitmap(width, height);
            //
            Graphics g = Graphics.FromImage(bm);
            Matrix matrix = new Matrix(1, 0, 0, -1, 0, height);
            g.Transform = matrix;
            g.SmoothingMode = SmoothingMode.AntiAlias;
            //网格绘制
            Pen pen = new Pen(Color.Black);
            g.DrawLine(pen, new Point(0, height / 2), new Point(width, height / 2));
            g.DrawLine(pen, new Point(20, 0), new Point(20, height));
            //
            SolidBrush brush = new SolidBrush(Color.Black);
            g.ResetTransform();
            g.DrawString("0", this.Font, brush, 5, height / 2);
            g.Transform = matrix;
            //
            pen = new Pen(Color.Green);
            pen.DashPattern = new float[] { 3f, 5f };
            int n = (int)((width - 20) / 30);



            for (int i = 0; i < n; i++)
            {
                int _x = (i + 1) * 30 + 20;
                g.DrawLine(pen, new Point(_x, 0), new Point(_x, height));
                //
                g.ResetTransform();
                string txt = (i + 1).ToString();
                g.DrawString(txt, this.Font, brush, _x - 5, height / 2);
                g.Transform = matrix;
            }
            n = (int)((height / 2) / 30);
            for (int i = 0; i < n; i++)
            {
                int _y = (i + 1) * 30 + height / 2;
                g.DrawLine(pen, new Point(20, _y), new Point(width, _y));
                //
                g.ResetTransform();
                string txt = ((i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, 25, height - _y - 5);
                g.Transform = matrix;
            }

            for (int i = 0; i < n; i++)
            {
                int _y = height / 2 - (i + 1) * 30;
                g.DrawLine(pen, new Point(20, _y), new Point(width, _y));
                //
                g.ResetTransform();
                string txt = (-(i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, 25, height - _y - 5);
                g.Transform = matrix;
            }
            //轨迹绘制
            pen = new Pen(Color.Red);
            float nx = 1f / 30f;
            float ny = 2000f / 30f;
            for (int i = 0; i < _VTPointsX.Count; i++)
            {
                if (i > 0)
                {
                    g.DrawLine(pen, new PointF(_VTPointsX[i].X / nx + 20, _VTPointsX[i].Y / ny + height / 2), new PointF(_VTPointsX[i - 1].X / nx + 20, _VTPointsX[i - 1].Y / ny + height / 2));
                }
            }
            pen = new Pen(Color.Brown);
            for (int i = 0; i < _VTPointsY.Count; i++)
            {
                if (i > 0)
                {
                    g.DrawLine(pen, new PointF(_VTPointsY[i].X / nx + 20, _VTPointsY[i].Y / ny + height / 2), new PointF(_VTPointsY[i - 1].X / nx + 20, _VTPointsY[i - 1].Y / ny + height / 2));
                }


            }
            pen = new Pen(Color.Blue);
            for (int i = 0; i < _VTPointsZ.Count; i++)
            {
                if (i > 0 && i < 45)
                {
                    g.DrawLine(pen, new PointF(_VTPointsZ[i].X / nx + 20, _VTPointsZ[i].Y / ny + height / 2), new PointF(_VTPointsZ[i - 1].X / nx + 20, _VTPointsZ[i - 1].Y / ny + height / 2));
                }
                if (i > 45)
                {
                    g.DrawLine(pen, new PointF(_VTPointsZ[i].X / nx + 20, (_VTPointsZ[i].Y / -ny + height / 2)), new PointF(_VTPointsZ[i - 1].X / nx + 20, (_VTPointsZ[i - 1].Y / -ny + height / 2)));
                }
            }
            int a = 0;
            a = _VTPointsZ.Count;

            //绘制原始数据
            for (int i = 0; i < _SpeedX.Length; i++)
            {
                float _x = (float)_Time[i] / nx + 20;
                float _y = (float)_SpeedX[i] / ny + height / 2;
                g.FillEllipse(new SolidBrush(Color.Red), new RectangleF(_x - 2f, _y - 2f, 4f, 4f));
            }
            for (int i = 0; i < _SpeedY.Length; i++)
            {
                float _x = (float)_Time[i] / nx + 20;
                float _y = (float)_SpeedY[i] / ny + height / 2;
                g.FillEllipse(new SolidBrush(Color.Brown), new RectangleF(_x - 2f, _y - 2f, 4f, 4f));
            }
            for (int i = 0; i < _SpeedZ.Length; i++)
            {
                float _x = (float)_Time[i] / nx + 20;
                float _y = (float)_SpeedZ[i] / ny + height / 2;
                g.FillEllipse(new SolidBrush(Color.Blue), new RectangleF(_x - 2f, _y - 2f, 4f, 4f));
            }
            g.Dispose();
            //
            pictureBox1.Image = bm;
        }
        private void DrawPTImage()
        {
            int width = pictureBox2.Width;
            int height = pictureBox2.Height;
            //
            Bitmap bm = new Bitmap(width, height);
            //
            Graphics g = Graphics.FromImage(bm);
            Matrix matrix = new Matrix(1, 0, 0, -1, 0, height);
            g.Transform = matrix;
            g.SmoothingMode = SmoothingMode.AntiAlias;
            //网格绘制
            Pen pen = new Pen(Color.Black);
            g.DrawLine(pen, new Point(0, 20), new Point(width, 20));
            g.DrawLine(pen, new Point(20, 0), new Point(20, height));
            //
            SolidBrush brush = new SolidBrush(Color.Black);
            g.ResetTransform();
            g.DrawString("0", this.Font, brush, 5, height - 15);
            g.Transform = matrix;
            //
            pen = new Pen(Color.Green);
            pen.DashPattern = new float[] { 3f, 5f };
            int n = (int)((width - 20) / 30);
            for (int i = 0; i < n; i++)
            {
                int _x = (i + 1) * 30 + 20;
                g.DrawLine(pen, new Point(_x, 20), new Point(_x, height));
                //
                g.ResetTransform();
                string txt = (i + 1).ToString();
                g.DrawString(txt, this.Font, brush, _x - 5, height - 15);
                g.Transform = matrix;
            }
            n = (int)((height - 20) / 30);
            for (int i = 0; i < n; i++)
            {
                int _y = (i + 1) * 30 + 20;
                g.DrawLine(pen, new Point(20, _y), new Point(width, _y));
                //
                g.ResetTransform();
                string txt = ((i + 1) * 3000).ToString();
                g.DrawString(txt, this.Font, brush, 25, height - _y - 5);
                g.Transform = matrix;
            }
            //轨迹绘制
            pen = new Pen(Color.Red);
            float nx = 1f / 30f;
            float ny = 3000f / 30f;
            for (int i = 0; i < _PTPointsX.Count; i++)
            {
                if (i > 0)
                {
                    g.DrawLine(pen, new PointF(_PTPointsX[i].X / nx + 20, (_PTPointsX[i].Y / ny + 20)), new PointF(_PTPointsX[i - 1].X / nx + 20, (_PTPointsX[i - 1].Y / ny + 20)));
                }
            }
            pen = new Pen(Color.Brown);
            for (int i = 0; i < _PTPointsY.Count; i++)
            {
                if (i > 0)
                {
                    g.DrawLine(pen, new PointF(_PTPointsY[i].X / nx + 20, _PTPointsY[i].Y / ny + 20), new PointF(_PTPointsY[i - 1].X / nx + 20, _PTPointsY[i - 1].Y / ny + 20));
                }
            }
            pen = new Pen(Color.Blue);
            for (int i = 0; i < _PTPointsZ.Count; i++)
            {
                if (i > 0)
                {
                    g.DrawLine(pen, new PointF(_PTPointsZ[i].X / nx + 20, _PTPointsZ[i].Y / ny + 20), new PointF(_PTPointsZ[i - 1].X / nx + 20, _PTPointsZ[i - 1].Y / ny + 20));
                }
            }
            //绘制原始数据
            for (int i = 0; i < _PosX.Length; i++)
            {
                float _x = (float)_Time[i] / nx + 20;
                float _y = (float)_PosX[i] / ny + 20;
                g.FillEllipse(new SolidBrush(Color.Red), new RectangleF(_x - 2f, _y - 2f, 4f, 4f));
            }
            for (int i = 0; i < _PosY.Length; i++)
            {
                float _x = (float)_Time[i] / nx + 20;
                float _y = (float)_PosY[i] / ny + 20;
                g.FillEllipse(new SolidBrush(Color.Brown), new RectangleF(_x - 2f, _y - 2f, 4f, 4f));
            }
            for (int i = 0; i < _PosZ.Length; i++)
            {
                float _x = (float)_Time[i] / nx + 20;
                float _y = (float)_PosZ[i] / ny + 20;
                g.FillEllipse(new SolidBrush(Color.Blue), new RectangleF(_x - 2f, _y - 2f, 4f, 4f));
            }

            g.Dispose();
            //
            pictureBox2.Image = bm;
        }
        private void DrawPosImage()
        {
            int width = pictureBox3.Width;
            int height = pictureBox3.Height;
            //
            Bitmap bm = new Bitmap(width, height);
            //
            Graphics g = Graphics.FromImage(bm);
            Matrix matrix = new Matrix(1, 0, 0, -1, 0, height);
            g.Transform = matrix;
            g.SmoothingMode = SmoothingMode.AntiAlias;
            //网格绘制
            Pen pen = new Pen(Color.Black);
            g.DrawLine(pen, new Point(50, height / 2), new Point(height / 2 + 50, 0));
            g.DrawLine(pen, new Point(50, height / 2), new Point(height / 2 + 50, height));
            g.DrawLine(pen, new Point(50, height / 2), new Point(50, height));
            //
            SolidBrush brush = new SolidBrush(Color.Black);
            g.ResetTransform();
            g.DrawString("0", this.Font, brush, 40, height / 2);
            g.Transform = matrix;
            //
            //轨迹绘制
            pen = new Pen(Color.Red);
            float nx = 5000f / 50f;
            float ny = 5000f / 50f;
            for (int i = 0; i < _PointsX.Count; i++)
            {
                if (i > 0)
                {
                    PointF _pt0 = ToPointF(_PointsX[i], _PointsY[i], _PointsZ[i]);
                    PointF _pt1 = ToPointF(_PointsX[i - 1], _PointsY[i - 1], _PointsZ[i - 1]);
                    g.DrawLine(pen, new PointF(_pt0.X / nx + 50, _pt0.Y / ny + height / 2), new PointF(_pt1.X / nx + 50, _pt1.Y / ny + height / 2));
                }
            }

            //绘制原始数据
            for (int i = 0; i < _PosX.Length; i++)
            {
                PointF _pt = ToPointF(_PosX[i], _PosY[i], _PosZ[i]);
                float _x = (float)_pt.X / nx + 50;
                float _y = (float)_pt.Y / ny + height / 2;
                g.FillEllipse(new SolidBrush(Color.Red), new RectangleF(_x - 2f, _y - 2f, 4f, 4f));
            }

            g.Dispose();
            //
            pictureBox3.Image = bm;
        }
        private PointF ToPointF(double x, double y, double z)
        {
            double _x = (y + x) * Math.Cos(Math.PI / 4);
            double _y = (z + (y - x) * Math.Cos(Math.PI / 4));
            return new PointF((float)_x, (float)_y);
        }

        private ushort GetAxisX()
        {
            return decimal.ToUInt16(numericUpDown1.Value);
        }
        private ushort GetAxisY()
        {
            return decimal.ToUInt16(numericUpDown2.Value);
        }
        private ushort GetAxisZ()
        {
            return decimal.ToUInt16(numericUpDown3.Value);
        }
        private bool _IsRun = false;

        private void button1_Click(object sender, EventArgs e)
        {
            if (_IsRun)
                return;
            _IsRun = true;
            numericUpDown1.Enabled = false;
            numericUpDown2.Enabled = false;
            numericUpDown3.Enabled = false;
            _VTPointsX.Clear();
            _PTPointsX.Clear();
            _VTPointsY.Clear();
            _PTPointsY.Clear();
            _PointsX.Clear();
            _PointsY.Clear();
            _PointsZ.Clear();
            DrawVTImage();
            DrawPTImage();
            DrawPosImage();
            //下载数据
            bool pvt = radioButton1.Checked;
            ushort axisx = GetAxisX();
            ushort axisy = GetAxisY();
            ushort axisz = GetAxisZ();
            if (pvt)
            {
                LTDMC.dmc_PvtTable(_CardID, axisx, (uint)_PosX.Length, _Time, _PosX, _SpeedX);
                LTDMC.dmc_PvtTable(_CardID, axisy, (uint)_PosY.Length, _Time, _PosY, _SpeedY);
                LTDMC.dmc_PvtTable(_CardID, axisz, (uint)_PosZ.Length, _Time, _PosZ, _SpeedZ);
            }
            else
            {
                LTDMC.dmc_PvtsTable(_CardID, axisx, (uint)_PosX.Length, _Time, _PosX, 0, 0);
                LTDMC.dmc_PvtsTable(_CardID, axisy, (uint)_PosY.Length, _Time, _PosY, 0, 0);
                LTDMC.dmc_PvtsTable(_CardID, axisz, (uint)_PosZ.Length, _Time, _PosZ, 0, 0);
            }
            _StartTime = DateTime.Now;
            LTDMC.dmc_PvtMove(_CardID, 3, new ushort[] { axisx, axisy, axisz });
            //等待电机停止
            ThreadPool.QueueUserWorkItem(
                delegate
                {
                    while (_IsRun)
                    {
                        if (LTDMC.dmc_check_done(_CardID, axisx) == 0 || LTDMC.dmc_check_done(_CardID, axisy) == 0 || LTDMC.dmc_check_done(_CardID, axisz) == 0)
                        {
                            Thread.Sleep(10);
                            continue;
                        }
                        else
                        {
                            break;
                        }
                    }
                    _IsRun = false;
                    try
                    {
                        this.Invoke(
                            (MethodInvoker)delegate
                            {
                                numericUpDown1.Enabled = true;
                                numericUpDown2.Enabled = true;
                                numericUpDown3.Enabled = true;
                            }
                            );
                    }
                    catch (System.Exception ex)
                    {

                    }
                }
                );
        }

        private void button2_Click(object sender, EventArgs e)
        {
            LTDMC.dmc_set_position_unit(_CardID, GetAxisX(), 0);
            LTDMC.dmc_set_position_unit(_CardID, GetAxisY(), 0);
            LTDMC.dmc_set_position_unit(_CardID, GetAxisZ(), 0);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            _IsRun = false;
            ushort axisx = GetAxisX();
            ushort axisy = GetAxisY();
            ushort axisz = GetAxisZ();
            LTDMC.dmc_stop(_CardID, axisx, 1);
            LTDMC.dmc_stop(_CardID, axisy, 1);
            LTDMC.dmc_stop(_CardID, axisz, 1);
        }
        

        private void button4_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            ushort axisx = GetAxisX();
            ushort axisy = GetAxisY();
            ushort axisz = GetAxisZ();
            DateTime now = DateTime.Now;
            double speedx = 0;
            LTDMC.dmc_read_current_speed_unit(_CardID, axisx, ref speedx);
            double posx = 0;
            LTDMC.dmc_get_position_unit(_CardID, axisx, ref posx);
            double speedy = 0;
            LTDMC.dmc_read_current_speed_unit(_CardID, axisy, ref speedy);
            double posy = 0;
            LTDMC.dmc_get_position_unit(_CardID, axisy, ref posy);
            double speedz = 0;
            LTDMC.dmc_read_current_speed_unit(_CardID, axisz, ref speedz);
            double posz = 0;
            LTDMC.dmc_get_position_unit(_CardID, axisz, ref posz);
            //
            if (_IsRun)
            {
                TimeSpan ts = now - _StartTime;
                _VTPointsX.Add(new PointF((float)ts.TotalSeconds, (float)speedx));
                _PTPointsX.Add(new PointF((float)ts.TotalSeconds, (float)posx));
                _VTPointsY.Add(new PointF((float)ts.TotalSeconds, (float)speedy));
                _PTPointsY.Add(new PointF((float)ts.TotalSeconds, (float)posy));
                _VTPointsZ.Add(new PointF((float)ts.TotalSeconds, (float)speedz));
                _PTPointsZ.Add(new PointF((float)ts.TotalSeconds, (float)posz));
                _PointsX.Add(posx);
                _PointsY.Add(posy);
                _PointsZ.Add(posz);
                DrawVTImage();
                DrawPTImage();
                DrawPosImage();
                textBox4.Text = ts.TotalSeconds.ToString();
            }
            //
            textBox1.Text = speedx.ToString();
            textBox2.Text = posx.ToString();
            textBox6.Text = speedy.ToString();
            textBox7.Text = posy.ToString();
            textBox8.Text = speedz.ToString();
            textBox9.Text = posz.ToString();
            if (LTDMC.dmc_check_done(_CardID, axisx) == 0 || LTDMC.dmc_check_done(_CardID, axisy) == 0 || LTDMC.dmc_check_done(_CardID, axisz) == 0)
            {
                textBox3.Text = "运动中";
            }
            else
            {
                textBox3.Text = "停止中";
            }

            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardID, 2, ref errcode);
            if (errcode == 0)
            {
                textBox10.Text = "EtherCAT总线正常";
                textBox10.BackColor = Color.Green;
            }
            else
            {
                textBox10.Text = "EtherCAT总线出错";
                textBox10.BackColor = Color.Red;
            }               
        }
        
        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            RefreshText();
        }

        private void radioButton3_CheckedChanged_1(object sender, EventArgs e)
        {
            RefreshText();
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            RefreshText();
        }
    }
}
