﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using csLTDMC;
using System.Threading;

namespace 回原点运动
{
    public partial class Form1 : Form
    {
        private ushort _CardID = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short num = LTDMC.dmc_board_init();//获取卡数量
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
            }
            ushort _num = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short res = LTDMC.dmc_get_CardInfList(ref _num, cardtypes, cardids);
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
            }
            _CardID = cardids[0];
            //
            timer1.Start();
        }



        private ushort GetAxis()
        {
            return decimal.ToUInt16(numericUpDown6.Value);
        }
       
       
        //运行
        private void button1_Click(object sender, EventArgs e)
        {
            ushort state = 0;
            ushort axis = GetAxis();
            short res = LTDMC.nmc_home_move(_CardID, axis);//启动回零     
            if (res != 0)
            {
                MessageBox.Show("nmc_home_move == " + res.ToString());
                return;
            }
            while (LTDMC.dmc_check_done(_CardID, axis) == 0)//等待运动停止
            {
                Application.DoEvents();
            }
            res = LTDMC.dmc_get_home_result(_CardID, axis,ref state);//判断回零结果
            if (res == 0)
            {
                if (state == 1)
                {
                    MessageBox.Show("回零成功!");
                }
                else
                {
                    MessageBox.Show("回零失败!");
                }
            }
            else
            {
                MessageBox.Show("dmc_get_home_result == " + res.ToString());
            }
            
        }

        private void button3_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis();
            LTDMC.dmc_stop(_CardID, axis, 0);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis();
            LTDMC.dmc_set_position(_CardID, axis, 0);//位置清零
        }

        private void button5_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis();
            LTDMC.dmc_stop(_CardID, axis, 1);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            double dcurrent_speed = 0;//速度值
            double dunitPos = 0; //指令位置
            double encPos = 0; //反馈位置
            ushort Axis_State_machine = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, axis, ref Axis_State_machine);
            switch (Axis_State_machine)// 读取指定轴状态机
            {
                case 0: textBox5.Text = "NOT_READY_SWITCH_ON";
                    textBox5.BackColor = Color.Red;
                    break;
                case 1:
                    textBox5.Text = "SWITCH_ON_DISABLE";
                    textBox5.BackColor = Color.Red;
                    break;
                case 2:
                    textBox5.Text = "READY_TO_DISABLE";
                    textBox5.BackColor = Color.Red;
                    break;
                case 3:
                    textBox5.Text = "SWOTCH_ON";
                    textBox5.BackColor = Color.Red;
                    break;
                case 4:
                    textBox5.Text = "OP_ENABLE";
                    textBox5.BackColor = Color.Green;
                    break;
                case 5:
                    textBox5.Text = "QUICK_STOP";
                    textBox5.BackColor = Color.Red;
                    break;
                case 6:
                    textBox5.Text = "FAULT_ACTIVE";
                    textBox5.BackColor = Color.Red;
                    break;
                case 7:
                    textBox5.Text = "FAULT";
                    textBox5.BackColor = Color.Red;
                    break;
            };

            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardID, 2, ref errcode);
            if (errcode == 0)
            {
                textBox7.Text = "EtherCAT总线正常";
                textBox7.BackColor = Color.Green;
            }
            else
            {
                textBox7.Text = "EtherCAT总线出错";
                textBox7.BackColor = Color.Red;
            }

            LTDMC.dmc_read_current_speed_unit(_CardID, axis, ref dcurrent_speed); // 读取轴当前速度
            textBox6.Text = dcurrent_speed.ToString();
            LTDMC.dmc_get_position_unit(_CardID, axis, ref dunitPos); //读取指定轴指令位置值
            textBox2.Text = dunitPos.ToString();
            LTDMC.dmc_get_encoder_unit(_CardID, axis, ref encPos);//读取指定轴反馈位置值
            textBox3.Text = encPos.ToString();

            if (LTDMC.dmc_check_done(_CardID, axis) == 0) // 读取指定轴运动状态
            {
                textBox4.Text = "回零中";
                textBox4.BackColor = Color.Green;
            }
            else
            {
                textBox4.Text = "停止";
                textBox4.BackColor = Color.Red;
            }
            uint IoState = LTDMC.dmc_axis_io_status(_CardID, axis);
            if ((IoState & 2) == 2)//检测正限位信号
            {
                button4.BackColor = Color.Green;
            }
            else
            {
                button4.BackColor = Color.Red;
            }
            if ((IoState & 4) == 4)//检测负限位信号
            {
                button6.BackColor = Color.Green;
            }
            else
            {
                button6.BackColor = Color.Red;
            }
            if ((IoState &16) == 16)//检测原点信号
            {
                button3.BackColor = Color.Green;
            }
            else
            {
                button3.BackColor = Color.Red;
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Stop();
            LTDMC.dmc_board_close();
        }

        private void button10_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……" + "\n");
            button10.Enabled = false;
            button11.Enabled = false;
            //Application.DoEvents();
            LTDMC.dmc_board_reset();
            LTDMC.dmc_board_close();

            for (int i = 0; i < 15; i++)//总线卡硬件复位耗时15s左右
            {
                Application.DoEvents();
                Thread.Sleep(1000);
            }

            LTDMC.dmc_board_init();
            richTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button10.Focus();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡软件复位进行中……" + "\n");
            button11.Enabled = false;
            button10.Enabled = false;
            DateTime dt_start = DateTime.Now;
            short res = LTDMC.dmc_soft_reset(_CardID);
            if (res != 0)
            {
                MessageBox.Show("dmc_soft_reset == " + res.ToString());
                return;
            }
            ushort err = 0;
            while (true)
            {
                if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//设置超时退出，防止死循环
                {
                    MessageBox.Show("总线复位失败!");
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                res = LTDMC.nmc_get_errcode(_CardID, 2, ref err);
                if (res == 0)
                {
                    if (err == 0)//总线复位正常完成
                    {
                        break;
                    }
                }
                else
                {
                    MessageBox.Show("nmc_get_errcode == " + res.ToString());
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                Application.DoEvents();
            }
            richTextBox1.AppendText("总线卡软件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button11.Focus();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            LTDMC.nmc_set_axis_enable(_CardID, axis);// 使能对应轴
        }

        private void button9_Click(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            LTDMC.nmc_set_axis_disable(_CardID, axis);// 失能对应轴
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            short res = LTDMC.nmc_set_home_profile(_CardID, axis, Convert.ToUInt16(textBox10.Text), Convert.ToDouble(textBox9.Text), Convert.ToDouble(textBox1.Text), Convert.ToDouble(textBox8.Text), Convert.ToDouble(textBox8.Text), Convert.ToUInt16(textBox11.Text));
            if (res != 0)
            {
                MessageBox.Show("nmc_set_home_profile == " + res.ToString());
            }
        }
                

        private void button12_Click_1(object sender, EventArgs e)
        {
            ushort axis = GetAxis(); //轴号
            LTDMC.dmc_set_position_unit(_CardID, axis, 0);
        }
 
       
    }
}
