﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using csLTDMC;


namespace 定长运动
{
    public partial class Form1 : Form
    {
        private ushort _CardNo = 0;
        private bool m_bInit = false;
        public Form1()
        {
            InitializeComponent();
        }
        
        private void Form1_Load(object sender, EventArgs e)
        {
            
        }
        private void button_connect_Click(object sender, EventArgs e)
        {
            button_connect.Enabled = false;
            short res = 0;
            //uint totalAxis = 0;
            ushort err = 0;
            ushort cardnum = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short num = LTDMC.dmc_board_init();
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
                return;
            }
            
            res = LTDMC.dmc_get_CardInfList(ref cardnum, cardtypes, cardids);//获取控制卡信息
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
                button_connect.Enabled = true;
                return;
            }
            bool EtherCardFlag = false;
            for (ushort i = 0; i < cardnum; i++)
            {
                int _cardtype = (int)cardtypes[i];
                _cardtype = _cardtype & 0xfffff;
                if (_cardtype == 0x15032 || _cardtype == 0x13032)  //查找第一张E5032或E3032卡
                {
                    numericUpDown_cardNo.Value = new decimal(cardids[i]);
                    _CardNo = cardids[i];
                    EtherCardFlag = true;
                    break;
                }
            }
            if (!EtherCardFlag)
            {
                MessageBox.Show("PC中不存在EtherCAT总线卡!");
                button_connect.Enabled = true;
                return;
            }
            res = LTDMC.nmc_get_errcode(_CardNo, 2, ref err);//获取总线状态
            if (res == 0)
            {
                if (err != 0)//总线报错
                {
                    DateTime dt_start = DateTime.Now;
                    res = LTDMC.dmc_soft_reset(_CardNo);//复位总线错误
                    if (res != 0)
                    {
                        MessageBox.Show("dmc_soft_reset == " + res.ToString());
                        return;
                    }
                    while (true)
                    {
                        if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//设置超时退出，防止死循环
                        {
                            MessageBox.Show("总线复位失败!");
                            button_connect.Enabled = true;
                            return;
                        }
                        res = LTDMC.nmc_get_errcode(_CardNo, 2, ref err);
                        if (res == 0)
                        {
                            if (err == 0)//总线复位正常完成
                            {
                                break;
                            }
                        }
                        else
                        {
                            MessageBox.Show("nmc_get_errcode == " + res.ToString());
                            button_connect.Enabled = true;
                            return;
                        }
                        Application.DoEvents();
                    }
                }
            }
            
            //res = LTDMC.nmc_get_total_axes(_CardNo, ref totalAxis);
            //if (res != 0)
            //{
            //    MessageBox.Show("nmc_get_total_axes == " + res.ToString());
            //    return;
            //}
            MessageBox.Show("打开卡成功！");
            m_bInit = true;
            timer1.Start();
        }
        private void button_disconnect_Click(object sender, EventArgs e)
        {
            if (m_bInit == true)
            {
                short res = LTDMC.dmc_board_close();
                m_bInit = false;
            }
            button_connect.Enabled = true;
        }       
             
        private void timer1_Tick(object sender, EventArgs e)
        {
            ushort totalIn = 0;
            ushort totalOut = 0;
            LTDMC.nmc_get_total_ionum(_CardNo, ref totalIn, ref totalOut);
            textBox_in.Text = totalIn.ToString();
            textBox_out.Text = totalOut.ToString();

            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardNo, 2, ref errcode);
            if (errcode == 0)
            {
                textBox_ecState.Text = "EtherCAT总线正常";
                textBox_ecState.BackColor = Color.Green;
            }
            else
            {
                textBox_ecState.Text = "EtherCAT总线出错";
                textBox_ecState.BackColor = Color.Red;
            }
            //
            //输入口
            ushort nodeID = decimal.ToUInt16(nud_nodeID.Value);
            uint n=0;
            LTDMC.nmc_read_inport_extern(_CardNo, 2, nodeID, 0, ref n);
            //LTDMC.nmc_read_inport(_CardNo, nodeID, 0, ref n);
            //n = LTDMC.dmc_read_inport(_ConnectNo, 0);
            for (int i = 0; i < 16; i++)
            {
                Label label = GetINLabel(i);
                if (label != null)
                {
                    SetLabel(label, (n & 1) == 1);
                }
                n = n >> 1;
            }
            //输出口
            LTDMC.nmc_read_outport_extern(_CardNo, 2, nodeID, 0, ref n);
            //LTDMC.nmc_read_outport(_CardNo, nodeID, 0, ref n);
            //n = LTDMC.dmc_read_outport(_ConnectNo, 0);
            for (int i = 0; i < 16; i++)
            {
                Label label = GetOUTLabel(i);
                if (label != null)
                {
                    SetLabel(label, (n & 1) == 1);
                }
                n = n >> 1;
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Stop();
            LTDMC.dmc_board_close();
        }

        private void button_ecClearErr_Click(object sender, EventArgs e)
        {
            if (m_bInit)
            {
                button_ecClearErr.Enabled = false;
                DateTime dt_start = DateTime.Now;
                short res = LTDMC.dmc_soft_reset(_CardNo);
                if (res != 0)
                {
                    MessageBox.Show("dmc_soft_reset == " + res.ToString());
                    return;
                }
                ushort err = 0;
                while (true)
                {
                    if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//设置超时退出，防止死循环
                    {
                        MessageBox.Show("总线复位失败!");
                        button_ecClearErr.Enabled = true;
                        button_ecClearErr.Focus();
                        return;
                    }
                    res = LTDMC.nmc_get_errcode(_CardNo, 2, ref err);
                    if (res == 0)
                    {
                        if (err == 0)//总线复位正常完成
                        {
                            break;
                        }
                    }
                    else
                    {
                        MessageBox.Show("nmc_get_errcode == " + res.ToString());
                        button_ecClearErr.Enabled = true;
                        button_ecClearErr.Focus();
                        return;
                    }
                    Application.DoEvents();
                }
            }
            button_ecClearErr.Enabled = true;
            button_ecClearErr.Focus();
        }
        private Label GetINLabel(int index)
        {
            string txt = index.ToString();
            foreach (Label _label in groupBox_in.Controls)
            {
                if (_label != null && _label.Text == txt)
                {
                    return _label;
                }
            }
            return null;
        }
        private Label GetOUTLabel(int index)
        {
            string txt = index.ToString();
            foreach (Label _label in groupBox_out.Controls)
            {
                if (_label != null && _label.Text == txt)
                {
                    return _label;
                }
            }
            return null;
        }
        private void SetLabel(Label label, bool status)
        {
            if (label != null)
            {
                if (status)
                {
                    label.BackColor = Color.Red;
                }
                else
                {
                    label.BackColor = Color.Green;
                }
            }
        }
        private void labelOut_Click(object sender, EventArgs e)
        {
            int index = -1;
            ushort nodeID = decimal.ToUInt16(nud_nodeID.Value);
            ushort ioValue = 0;

            foreach (Label _label in groupBox_out.Controls)
            {
                if (_label == sender)
                {
                    index = Convert.ToInt32(_label.Text);
                    break;
                }
            }            
            if (m_bInit)
            {
                //按节点号读写IO
                if (index >= 0)
                {
                    short s = LTDMC.nmc_read_outbit_extern(_CardNo, 2, nodeID, (ushort)index, ref ioValue);
                    //short s = LTDMC.nmc_read_outbit(_CardNo, nodeID, (ushort)index, ref ioValue);
                    if (s != 0)
                    {
                        MessageBox.Show("nmc_read_outbit_extern == " + s.ToString());
                    }
                    if (ioValue == 1)
                    {
                        s = LTDMC.nmc_write_outbit_extern(_CardNo, 2, nodeID, (ushort)index, 0);
                        //s = LTDMC.nmc_write_outbit(_CardNo, nodeID, (ushort)index, 0);
                        if (s != 0)
                        {
                            MessageBox.Show("nmc_write_outbit_extern == " + s.ToString());
                        }
                    }
                    else
                    {
                        s = LTDMC.nmc_write_outbit_extern(_CardNo, 2, nodeID, (ushort)index, 1);
                        //s = LTDMC.nmc_write_outbit(_CardNo, nodeID, (ushort)index, 1);
                        if (s != 0)
                        {
                            MessageBox.Show("nmc_write_outbit_extern == " + s.ToString());
                        }
                    }
                }
            }
            //if (m_bInit)
            //{
            //    //不分节点自动排序IO方式读写
            //    if (index >= 0)
            //    {
            //        short s = LTDMC.dmc_read_outbit(_ConnectNo, (ushort)index);
            //        if (s == 1)
            //        {
            //            LTDMC.dmc_write_outbit(_ConnectNo, (ushort)(index), 0);
            //        }
            //        else
            //        {
            //            LTDMC.dmc_write_outbit(_ConnectNo, (ushort)(index), 1);
            //        }
            //    }
            //}          
        }
    }
}
