﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using csLTDMC;
using System.Threading;

namespace 低速二维位置比较
{
    public partial class Form1 : Form
    {
        private ushort _CardID = 0;
        private int[] _ComparePosX = null;
        private int[] _ComparePosY = null;

        public Form1()
        {
            InitializeComponent();
            _ComparePosX = new int[] { -5000, 5000 };
            _ComparePosY = new int[] { 5000, 5000 };
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short num = LTDMC.dmc_board_init();//获取卡数量
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
            }
            ushort _num = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short res = LTDMC.dmc_get_CardInfList(ref _num, cardtypes, cardids);
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
            }
            _CardID = cardids[0];
            
            //
            timer1.Start();
            DrawPosImage();
        }

        private List<PointF> _Points = new List<PointF>();
        private void DrawPosImage()
        {
            int width = pictureBox1.Width;
            int height = pictureBox1.Height;
            //
            Bitmap bm = new Bitmap(width, height);
            //
            Graphics g = Graphics.FromImage(bm);
            Matrix matrix = new Matrix(1, 0, 0, -1, 0, height);
            g.Transform = matrix;
            g.SmoothingMode = SmoothingMode.AntiAlias;
            //网格绘制
            Pen pen = new Pen(Color.Black);
            g.DrawLine(pen, new Point(0, 20), new Point(width, 20));
            g.DrawLine(pen, new Point(width / 2, 0), new Point(width / 2, height));
            //
            SolidBrush brush = new SolidBrush(Color.Black);
            g.ResetTransform();
            g.DrawString("0", this.Font, brush, width / 2 + 5, height - 15);
            g.Transform = matrix;
            //
            pen = new Pen(Color.Green);
            pen.DashPattern = new float[] { 3f, 5f };
            int n = (int)((width / 2) / 40);
            for (int i = 0; i < n; i++)
            {
                int _x = (i + 1) * 40 + width / 2;
                g.DrawLine(pen, new Point(_x, 20), new Point(_x, height));
                //
                g.ResetTransform();
                string txt = ((i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, _x - 15, height - 15);
                g.Transform = matrix;
            }
            for (int i = 0; i < n; i++)
            {
                int _x = width / 2 - (i + 1) * 40;
                g.DrawLine(pen, new Point(_x, 20), new Point(_x, height));
                //
                g.ResetTransform();
                string txt = (-(i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, _x - 20, height - 15);
                g.Transform = matrix;
            }
            n = (int)((height - 20) / 40);
            for (int i = 0; i < n; i++)
            {
                int _y = (i + 1) * 40 + 20;
                g.DrawLine(pen, new Point(0, _y), new Point(width, _y));
                //
                g.ResetTransform();
                string txt = ((i + 1) * 2000).ToString();
                g.DrawString(txt, this.Font, brush, width / 2 + 5, height - _y - 5);
                g.Transform = matrix;
            }
            //轨迹绘制
            pen = new Pen(Color.Red);
            float nx = 2000f / 40f;
            float ny = 2000f / 40f;
            for (int i = 0; i < _Points.Count; i++)
            {
                if (i > 0)
                {
                    g.DrawLine(pen, new PointF(_Points[i].X / nx + width / 2, _Points[i].Y / ny + 20), new PointF(_Points[i - 1].X / nx + width / 2, _Points[i - 1].Y / ny + 20));
                }
            }

            //绘制比较点
            for (int i = 0; i < _ComparePosX.Length; i++)
            {
                float _x = (float)_ComparePosX[i] / nx + width / 2;
                float _y = (float)_ComparePosY[i] / ny + 20;
                g.FillEllipse(new SolidBrush(Color.Blue), new RectangleF(_x - 2f, _y - 2f, 4f, 4f));
            }

            g.Dispose();
            //
            pictureBox1.Image = bm;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            _Points.Clear();
            DrawPosImage();
            //例程设置起始点为0，实际使用位置比较功能时，不需要调用dmc_set_position_unit指令
            LTDMC.dmc_set_position_unit(_CardID, 0, 0);
            LTDMC.dmc_set_position_unit(_CardID, 1, 0);
            //
            LTDMC.dmc_compare_set_config(_CardID, 0, 1,0);//设置比较器，0号卡0轴一维位置比较使能，比较源指令位置
            LTDMC.dmc_compare_clear_points(_CardID, 0);//清除比较器           

            LTDMC.dmc_compare_set_config(_CardID, 1, 1, 0);//设置比较器，0号卡1轴一维位置比较使能，比较源指令位置
            LTDMC.dmc_compare_clear_points(_CardID, 1);//清除比较器

            short iret = 0;
            uint cycle = 0;
            ushort level = 0;
            uint bitno = 0;
            //添加比较点
            iret = LTDMC.dmc_compare_add_point_cycle_unit(_CardID, 0, 3000, 1, bitno, cycle, level);//轴0大于等于3000，0号输出口置低电平
            if (iret != 0)
            {
                MessageBox.Show("dmc_compare_add_point_cycle_unit ==" + iret.ToString());
            }
            level = 1;
            iret = LTDMC.dmc_compare_add_point_cycle_unit(_CardID, 1, 6000, 1, bitno, cycle, level);//轴1大于等于6000，0号输出口置高电平
            if (iret != 0)
            {
                MessageBox.Show("dmc_compare_add_point_cycle_unit ==" + iret.ToString());
            }
            //运动指令
            LTDMC.dmc_set_vector_profile_unit(_CardID, 0, 0, 2000, 0.1, 0.1, 0);// X Y走直线插补运动
            LTDMC.dmc_line_unit(_CardID, 0, 2, new ushort[] { 0, 1 }, new double[] { 10000, 10000 }, 1);
        }

        

        private void button3_Click(object sender, EventArgs e)
        {
            timer1.Stop();
            LTDMC.dmc_board_close();
            this.Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            ushort Axis_State_machine0 = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, 0, ref Axis_State_machine0);
            switch (Axis_State_machine0)// 读取指定轴状态机
            {
                case 0: textBox5.Text = "轴处于未启动状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 1:
                    textBox5.Text = "轴处于启动禁止状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 2:
                    textBox5.Text = "轴处于准备启动状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 3:
                    textBox5.Text = "轴处于启动状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 4:
                    textBox5.Text = "轴处于操作使能状态";
                    textBox5.BackColor = Color.Green;
                    break;
                case 5:
                    textBox5.Text = "轴处于停止状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 6:
                    textBox5.Text = "轴处于错误触发状态";
                    textBox5.BackColor = Color.Red;
                    break;
                case 7:
                    textBox5.Text = "轴处于错误状态";
                    textBox5.BackColor = Color.Red;
                    break;
            };
            ushort Axis_State_machine1 = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, 1, ref Axis_State_machine1);
            switch (Axis_State_machine1)// 读取指定轴状态机
            {
                case 0: textBox4.Text = "轴处于未启动状态";
                    textBox4.BackColor = Color.Red;
                    break;
                case 1:
                    textBox4.Text = "轴处于启动禁止状态";
                    textBox4.BackColor = Color.Red;
                    break;
                case 2:
                    textBox4.Text = "轴处于准备启动状态";
                    textBox4.BackColor = Color.Red;
                    break;
                case 3:
                    textBox4.Text = "轴处于启动状态";
                    textBox4.BackColor = Color.Red;
                    break;
                case 4:
                    textBox4.Text = "轴处于操作使能状态";
                    textBox4.BackColor = Color.Green;
                    break;
                case 5:
                    textBox4.Text = "轴处于停止状态";
                    textBox4.BackColor = Color.Red;
                    break;
                case 6:
                    textBox4.Text = "轴处于错误触发状态";
                    textBox4.BackColor = Color.Red;
                    break;
                case 7:
                    textBox4.Text = "轴处于错误状态";
                    textBox4.BackColor = Color.Red;
                    break;
            };

            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardID, 2, ref errcode);
            if (errcode == 0)
            {
                textBox6.Text = "EtherCAT总线正常";
                textBox6.BackColor = Color.Green;
            }
            else
            {
                textBox6.Text = "EtherCAT总线出错";
                textBox6.BackColor = Color.Red;
            }
            double x = 0;
            LTDMC.dmc_get_position_unit(_CardID, 0, ref x);
            double y = 0;
            LTDMC.dmc_get_position_unit(_CardID, 1, ref y);
            if (_Points.Count > 0)
            {
                if (_Points[_Points.Count - 1].X != x || _Points[_Points.Count - 1].Y != y)
                {
                    _Points.Add(new PointF((float)x, (float)y));
                    DrawPosImage();
                }
            }
            else
            {
                _Points.Add(new PointF((float)x, (float)y));
                DrawPosImage();
            }
            if (LTDMC.dmc_check_done(_CardID, 0) == 0 || LTDMC.dmc_check_done(_CardID, 1) == 0)
            {
                textBox3.Text = "运动中";
             }
            else
            {
                textBox3.Text = "停止中";
            }
            textBox1.Text = x.ToString();
            textBox2.Text = y.ToString();
            if (LTDMC.dmc_read_outbit(_CardID, 0) == 0)
            {
                panel1.BackColor = Color.Green;
            }
            else
            {
                panel1.BackColor = Color.Red;
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……" + "\n");
            button10.Enabled = false;
            button11.Enabled = false;
            //Application.DoEvents();
            LTDMC.dmc_board_reset();
            LTDMC.dmc_board_close();

            for (int i = 0; i < 15; i++)//总线卡硬件复位耗时15s左右
            {
                Application.DoEvents();
                Thread.Sleep(1000);
            }

            LTDMC.dmc_board_init();
            richTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button10.Focus();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡软件复位进行中……" + "\n");
            button11.Enabled = false;
            button10.Enabled = false;
            DateTime dt_start = DateTime.Now;
            short res = LTDMC.dmc_soft_reset(_CardID);
            if (res != 0)
            {
                MessageBox.Show("dmc_soft_reset == " + res.ToString());
                return;
            }
            ushort err = 0;
            while (true)
            {
                if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//设置超时退出，防止死循环
                {
                    MessageBox.Show("总线复位失败!");
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                res = LTDMC.nmc_get_errcode(_CardID, 2, ref err);
                if (res == 0)
                {
                    if (err == 0)//总线复位正常完成
                    {
                        break;
                    }
                }
                else
                {
                    MessageBox.Show("nmc_get_errcode == " + res.ToString());
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                Application.DoEvents();
            }
            richTextBox1.AppendText("总线卡软件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button11.Focus();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            LTDMC.nmc_set_axis_enable(_CardID, 0);// 使能对应轴
            LTDMC.nmc_set_axis_enable(_CardID, 1);// 使能对应轴
        }

        private void button9_Click(object sender, EventArgs e)
        {
            LTDMC.nmc_set_axis_disable(_CardID, 0);// 失能对应轴
            LTDMC.nmc_set_axis_disable(_CardID, 1);// 失能对应轴
        }

    }
}
