﻿
Public Class Form1

    Private _CardID As UShort
    Private axis(32) As UShort
    Private m_bInit As Boolean
    Private m_sevEnable As Boolean
    Private Sub Output(ByVal msg As String)
        Dim txt As String
        txt = String.Format("{0}:{1}{2}", DateTime.Now.ToString("HH:mm:ss"), msg, Environment.NewLine)
        textBox_msg.AppendText(txt)
    End Sub
    Private Sub Button_init_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_init.Click
        Button_init.Enabled = False
        Dim er As UShort
        Dim n As Short
        Dim res As Short
        Dim totalAxis As UInt32
        Dim cardnum As UShort
        Dim cardtypes(8) As UInt32
        Dim cardids(8) As UInt16
        n = dmc_board_init() '获取卡数量
        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            Output("初始化LTDMC卡失败！")
            Button_init.Enabled = True
            Return
        End If
        res = dmc_get_CardInfList(cardnum, cardtypes, cardids) '获取控制卡信息
        If (res <> 0) Then
            Output("获取卡信息失败!")
            Button_init.Enabled = True
            Return
        End If
        Dim EtherCardFlag As Boolean = False '定义脉冲卡是否存在标志
        Dim _cardtype As Int64 = 0
        For i As UShort = 0 To cardnum
            _cardtype = CType(cardtypes(i), Int64)
            _cardtype = _cardtype And &HFFFFF
            If (_cardtype = &H13032 OrElse _cardtype = &H15032) Then
                NumericUpDown_cardNo.Value = CType(cardids(i), Decimal)
                _CardID = cardids(i)
                EtherCardFlag = True
                Exit For
            End If
        Next
        If (Not EtherCardFlag) Then
            Output("PC中不存在EtherCAT总线卡!")
            Button_init.Enabled = True
            Return
        End If
        Dim dt_start As DateTime
        res = nmc_get_errcode(_CardID, 2, er) '获取总线状态
        If res = 0 Then
            If er <> 0 Then '总线报错
                dt_start = DateTime.Now
                res = dmc_soft_reset(_CardID) '复位总线错误
                If res <> 0 Then
                    Output("dmc_soft_reset == " + res.ToString())
                    Button_init.Enabled = True
                    Return
                End If
                Output("总线复位中... ")
                While True
                    If ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0) Then '超时退出循环
                        Output("总线复位失败！")
                        Button_init.Enabled = True
                        Return
                    End If
                    res = nmc_get_errcode(_CardID, 2, er)
                    If res = 0 Then
                        If er = 0 Then '总线复位正常完成
                            Exit While
                        End If
                    Else
                        Output("nmc_get_errcode == " + res.ToString())
                        Button_init.Enabled = True
                        Return
                    End If
                    Application.DoEvents()
                End While
            End If
        End If
        res = nmc_get_total_axes(_CardID, totalAxis) '获取当前卡的轴数
        If (res <> 0) Then
            Output("nmc_get_total_axes == " + res.ToString())
            Button_init.Enabled = True
            Return
        End If
        If (totalAxis <= 0) Then
            Output("控制卡未连接从站或未通过motion扫描下载从站配置信息！")
            Button_init.Enabled = True
            Return
        End If
        comboBox_axis.Items.Clear()
        For i As UShort = 0 To totalAxis - 1
            comboBox_axis.Items.Add(String.Format("{0:d}-Axis", i))
            axis(i) = i
        Next
        comboBox_axis.SelectedIndex = 0
        res = dmc_download_configfile(_CardID, "AxisPara.ini") '下载轴参数文件，通过motion参数配置导出的参数ini
        If (res <> 0) Then
            Output("dmc_download_configfile == " + res.ToString())
        End If
        GetAxisParam() '界面参数刷新
        m_bInit = True
        Output("初始化卡成功！")
        Timer1.Start() '
    End Sub
    Private Sub GetAxisParam()
        Dim res As Short = 0
        Dim start As Double
        Dim speed As Double
        Dim stopt As Double
        Dim acc As Double
        Dim dec As Double
        Dim s As Double
        Dim time As Double
        res = dmc_get_s_profile(_CardID, axis(comboBox_axis.SelectedIndex), 0, s) '设置S段时间（0-1s)
        If res <> 0 Then
            Output("smc_get_s_profile == " + res.ToString())
            Return
        End If
        numericUpDown_spara.Value = New Decimal(s)
        res = dmc_get_profile_unit(_CardID, axis(comboBox_axis.SelectedIndex), start, speed, acc, dec, stopt) '设置起始速度、运行速度、停止速度、加速时间、减速时间
        If res <> 0 Then
            Output("dmc_get_profile_unit == " + res.ToString())
            Return
        End If
        numericUpDown_startVel.Value = New Decimal(start)
        numericUpDown_vel.Value = New Decimal(speed)
        numericUpDown_acc.Value = New Decimal(acc)
        numericUpDown_dec.Value = New Decimal(dec)
        numericUpDown_stopVel.Value = New Decimal(stopt)
        res = dmc_get_dec_stop_time(_CardID, axis(comboBox_axis.SelectedIndex), time) '获取异常减速停止时间
        If res <> 0 Then
            Output("dmc_get_dec_stop_time == " + res.ToString())
            Return
        End If
    End Sub
    Private Sub Button_close_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_close.Click
        If (m_bInit = True) Then
            Timer1.Stop()
            dmc_board_close()
            m_bInit = False
            Button_init.Enabled = True
        End If
    End Sub
    Private Function GetMoveMode() As UShort
        Dim MoveMode As UShort = 0
        If radioButton_rel.Checked Then
            MoveMode = 0
        Else
            MoveMode = 1
        End If
        Return MoveMode

    End Function

    Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
        Dim res As Short
        Dim movemode As UShort
        Dim dist As Double
        dist = Decimal.ToDouble(numericUpDown_movePos.Value)
        movemode = GetMoveMode()
        If m_bInit Then
            If m_sevEnable Then
                res = dmc_pmove_unit(_CardID, axis(comboBox_axis.SelectedIndex), dist, movemode)
                If res <> 0 Then
                    Output("dmc_pmove_unit == " + res.ToString())
                End If
            Else
                Output("轴未使能，请先使能后再操作！")
            End If
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
        Dim axs As UShort
        Dim s As Double
        Dim up As Double
        Dim p As Double

        axs = axis(comboBox_axis.SelectedIndex)
        dmc_read_current_speed_unit(_CardID, axs, s) '
        textBox1.Text = Str(s) '
        dmc_get_position_unit(_CardID, axs, up) '
        textBox2.Text = Str(up) '
        dmc_get_encoder_unit(_CardID, axs, p) '
        textBox3.Text = Str(p) '

        Dim Axis_State_machine As UShort = 0
        nmc_get_axis_state_machine(_CardID, axs, Axis_State_machine)
        Select Case Axis_State_machine
            Case 0
                textBox_axisState.Text = "轴处于未启动状态"
                textBox_axisState.BackColor = Color.Red
            Case 1
                textBox_axisState.Text = "轴处于启动禁止状态"
                textBox_axisState.BackColor = Color.Red
            Case 2
                textBox_axisState.Text = "轴处于准备启动状态"
                textBox_axisState.BackColor = Color.Red
            Case 3
                textBox_axisState.Text = "轴处于启动状态"
                textBox_axisState.BackColor = Color.Red
            Case 4
                textBox_axisState.Text = "轴处于操作使能状态"
                textBox_axisState.BackColor = Color.Green
            Case 5
                textBox_axisState.Text = "轴处于停止状态"
                textBox_axisState.BackColor = Color.Red
            Case 6
                textBox_axisState.Text = "轴处于错误触发状态"
                textBox_axisState.BackColor = Color.Red
            Case 7
                textBox_axisState.Text = "轴处于错误状态"
                textBox_axisState.BackColor = Color.Red              
        End Select

        If Axis_State_machine = 4 Then
            Button_enable.Text = "失能"
            m_sevEnable = True
        Else
            Button_enable.Text = "使能"
            m_sevEnable = False
        End If

        Dim errcode As UShort = 0
        nmc_get_errcode(_CardID, 2, errcode)
        If errcode = 0 Then
            textBox_ecState.Text = "EtherCAT总线正常"
            textBox_ecState.BackColor = Color.Green
        Else
            textBox_ecState.Text = "EtherCAT总线出错"
            textBox_ecState.BackColor = Color.Red
        End If

        If (dmc_check_done(_CardID, axs) = 0) Then
            textBox4.Text = "运行中" '
        Else
            textBox4.Text = "停止中" '
        End If

    End Sub

    Private Sub button4_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button4.Click
        Dim res As Short
        If m_bInit Then
            res = dmc_stop(_CardID, axis(comboBox_axis.SelectedIndex), 0) '
            If res <> 0 Then
                Output("dmc_stop == " + res.ToString())
            End If
        End If

    End Sub

    Private Sub button5_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button5.Click
        Dim res As Short
        If m_bInit Then
            res = dmc_set_position_unit(_CardID, axis(comboBox_axis.SelectedIndex), 0) '
            If res <> 0 Then
                Output("dmc_set_position_unit == " + res.ToString())
            End If
        End If
    End Sub

    Private Sub button7_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.Close() '
    End Sub  
    Private Sub Button_enable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_enable.Click
        If (m_bInit <> True) Then
            Output("使能前请初始化控制卡！")
            Return
        End If
        Dim res As Short = 0
        If (m_sevEnable) Then
            res = nmc_set_axis_disable(_CardID, axis(comboBox_axis.SelectedIndex)) '失能对应轴
            If res <> 0 Then
                Output("nmc_set_axis_disable == " + res.ToString())
                Return
            End If
        Else
            res = nmc_set_axis_enable(_CardID, axis(comboBox_axis.SelectedIndex)) '使能对应轴
            If res <> 0 Then
                Output("nmc_set_axis_enable == " + res.ToString())
                Return
            End If
        End If
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        If m_bInit Then
            Timer1.Stop()
            dmc_board_close()
        End If
        
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim res As Short = 0
        Dim start As Double
        Dim speed As Double
        Dim stopt As Double
        Dim acc As Double
        Dim dec As Double
        Dim s As Double
        start = Decimal.ToDouble(numericUpDown_startVel.Value)
        speed = Decimal.ToDouble(numericUpDown_vel.Value)
        stopt = Decimal.ToDouble(numericUpDown_stopVel.Value)
        acc = Decimal.ToDouble(numericUpDown_acc.Value)
        dec = Decimal.ToDouble(numericUpDown_dec.Value)
        s = Decimal.ToDouble(numericUpDown_spara.Value)
        If m_bInit Then
            res = dmc_set_s_profile(_CardID, axis(comboBox_axis.SelectedIndex), 0, s) '设置S段时间（0-1s)
            If res <> 0 Then
                Output("dmc_set_s_profile == " + res.ToString())
                Return
            End If
            res = dmc_set_profile_unit(_CardID, axis(comboBox_axis.SelectedIndex), start, speed, acc, dec, stopt) '设置起始速度、运行速度、停止速度、加速时间、减速时间
            If res <> 0 Then
                Output("dmc_set_profile_unit == " + res.ToString())
                Return
            End If
            res = dmc_set_dec_stop_time(_CardID, axis(comboBox_axis.SelectedIndex), dec)
            If res <> 0 Then
                Output("dmc_set_dec_stop_time == " + res.ToString())
                Return
            End If
            GetAxisParam()
        End If
    End Sub

    Private Sub Button7_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Dim res As Short
        If m_bInit Then
            res = dmc_emg_stop(_CardID) '
            If res <> 0 Then
                Output("dmc_emg_stop == " + res.ToString())
            End If
        End If
    End Sub

    Private Sub 清空ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 清空ToolStripMenuItem.Click
        textBox_msg.Clear()
    End Sub

    Private Sub button_left_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles button_left.MouseDown
        Dim res As Short = 0
        If m_bInit Then
            If m_sevEnable Then '轴使能
                res = dmc_vmove(_CardID, axis(comboBox_axis.SelectedIndex), 0) '负方向运动
                If (res <> 0) Then
                    Output("dmc_vmove == " + res.ToString())
                
                End If
            Else
                Output("轴未使能，请先使能后再操作！")
            End If
        End If

    End Sub


    Private Sub button_left_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles button_left.MouseUp
        Dim res As Short = 0
        If m_bInit Then
            res = dmc_stop(_CardID, axis(comboBox_axis.SelectedIndex), 0) ' 减速停止
            If (res <> 0) Then
                Output("dmc_stop == " + res.ToString())
            End If
        End If

    End Sub


    Private Sub button_right_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles button_right.MouseDown
        Dim res As Short = 0
        If m_bInit Then
            If m_sevEnable Then '轴使能
                res = dmc_vmove(_CardID, axis(comboBox_axis.SelectedIndex), 1) '正方向运动
                If (res <> 0) Then

                    Output("dmc_vmove == " + res.ToString())
                End If
            Else
                Output("轴未使能，请先使能后再操作！")
            End If
        End If
    End Sub

    Private Sub button_right_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles button_right.MouseUp
        Dim res As Short = 0
        If m_bInit Then
            res = dmc_stop(_CardID, axis(comboBox_axis.SelectedIndex), 0) ' 减速停止
            If (res <> 0) Then
                Output("dmc_stop == " + res.ToString())
            End If
        End If
    End Sub

    Private Sub button_errClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_errClear.Click
        Dim res As Short = 0
        If m_bInit Then
            res = nmc_clear_axis_errcode(_CardID, axis(comboBox_axis.SelectedIndex)) '清除轴错误
            If res <> 0 Then
                Output("nmc_clear_axis_errcode == " + res.ToString())
            End If
        End If
    End Sub

    Private Sub button_ecClearErr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button_ecClearErr.Click
        Dim res As Short = 0
        If m_bInit Then
            res = nmc_clear_errcode(_CardID, 2) '清除总线错误
            If res <> 0 Then
                Output("nmc_clear_errcode == " + res.ToString())
            End If
        End If
    End Sub
End Class
