﻿Imports System.Threading

Public Class Form1
    Public _CardID As Short
    Dim axis As UShort = 0
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim n As Short
        Dim cardtypes(8) As UInteger
        Dim cardids(8) As UShort
        n = dmc_board_init() '获取卡数量

        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            MsgBox("初始化LTDMC卡失败！", vbOKOnly, "出错")
        Else
            MsgBox("初始化LTDMC卡成功！", vbOKOnly, "OK")
        End If
        dmc_get_CardInfList(n, cardtypes, cardids) '
        _CardID = cardids(0) '
        Timer1.Start() '
    End Sub


    Private Sub ContiStart_Click(sender As Object, e As EventArgs) Handles ContiStart.Click
        dmc_set_profile_unit(_CardID, axis, 0, 10000, 0.1, 0.1, 0)
        dmc_pmove_unit(_CardID, axis, 100000, 1)
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim errcode As Int32
        Dim Axis_State_machine As Int32
        nmc_get_errcode(_CardID, 2, errcode)
        If (errcode = 0) Then
            TextBox6.Text = "EtherCAT总线正常"
            TextBox6.BackColor = Color.Green
        Else
            TextBox6.Text = "EtherCAT总线出错"
            TextBox6.BackColor = Color.Red
        End If
        nmc_get_axis_state_machine(_CardID, axis, Axis_State_machine)
        Select Case (Axis_State_machine) ' 读取指定轴状态机

            Case 0 : TextBox5.Text = "轴处于未启动状态"
                TextBox5.BackColor = Color.Red

            Case 1
                TextBox5.Text = "轴处于启动禁止状态"
                TextBox5.BackColor = Color.Red

            Case 2
                TextBox5.Text = "轴处于准备启动状态"
                TextBox5.BackColor = Color.Red

            Case 3
                TextBox5.Text = "轴处于启动状态"
                TextBox5.BackColor = Color.Red

            Case 4
                TextBox5.Text = "轴处于操作使能状态"
                TextBox5.BackColor = Color.Green

            Case 5
                TextBox5.Text = "轴处于停止状态"
                TextBox5.BackColor = Color.Red

            Case 6
                TextBox5.Text = "轴处于错误触发状态"
                TextBox5.BackColor = Color.Red

            Case 7
                TextBox5.Text = "轴处于错误状态"
                TextBox5.BackColor = Color.Red

        End Select

        Dim ZSpeed As Double
        Dim ZPos As Double
        dmc_read_current_speed_unit(_CardID, axis, ZSpeed)

        ZActVel.Text = ZSpeed.ToString()

        dmc_get_position_unit(_CardID, axis, ZPos)

        ZActPos.Text = ZPos.ToString()

        Dim Number As Int32
        Dim Latch_Pos As Double
        dmc_ltc_get_number(_CardID, 0, 0, Number)
        TextBox1.Text = Number.ToString()
        dmc_ltc_get_value_unit(_CardID, 0, 0, Latch_Pos)
        TextBox2.Text = Latch_Pos.ToString()

        Dim remained_points As Int32
        Dim current_point As Double
        Dim runed_point As Int32
        dmc_hcmp_get_current_state_unit(_CardID, 0, remained_points, current_point, runed_point)
        TextBox4.Text = current_point.ToString() '返回当前比较点位置
        TextBox3.Text = runed_point.ToString() '返回已比较点数


    End Sub

    Private Sub ZeroPos_Click(sender As Object, e As EventArgs) Handles ZeroPos.Click

        dmc_stop(_CardID, axis, 1)

    End Sub

    Private Sub button1_Click(sender As Object, e As EventArgs) Handles button1.Click
        Dim hcmp_0 As UShort = 0 '比较器号
        Dim cmp_mode_0 As UShort = 5 '比较模式，5线性
        Dim cmp_source As UShort = 1 '比较位置源，固定值 1：辅助编码器计数器
        Dim cmp_logic As UShort = 0 '有效电平： 0：低电平， 1：高电平
        Dim time As Int32 = 100000 '脉冲宽度，单位： us，取值范围： 1us~20s
        Dim cmp_pos As Double = 20000 '添加比较位置
        Dim increment As Double = 10000 '设置高速比较线性模式参数，位置增量值
        Dim count As Int32 = 4 '设置高速比较线性模式参数，比较次数


        dmc_hcmp_set_mode(_CardID, hcmp_0, cmp_mode_0) '//配置比较器0  比较模式

        dmc_hcmp_set_config(_CardID, hcmp_0, 0, cmp_source, cmp_logic, time) '//配置比较器0，比较源为辅助编码器计数器0

        dmc_hcmp_add_point_unit(_CardID, hcmp_0, cmp_pos) '配置比较器0  添加比较点位置

        dmc_hcmp_set_liner_unit(_CardID, hcmp_0, increment, count) '配置比较器0  设置线性比较参数
    End Sub

    Private Sub button7_Click(sender As Object, e As EventArgs) Handles button7.Click

        Dim latch_0 As UShort = 0 '锁存器0 
        Dim latch_source As UShort = 1 ' 锁存源，1：辅助编码器计数器
        Dim latch_mode As UShort = 0 '触发模式 0：单次锁存，1：连续锁存
        Dim latch_logic As UShort = 1 '触发方式 0：下降沿锁存，1：上升沿锁存
        Dim filter As Double = 100 '滤波时间

        dmc_ltc_reset(_CardID, latch_0) '复位锁存器0
        dmc_ltc_set_mode(_CardID, latch_0, latch_mode, latch_logic, filter) '配置锁存器0，锁存模式为单次锁存，上升沿锁存 
        dmc_ltc_set_source(_CardID, latch_0, 0, latch_source) '配置锁存器0，锁存源为辅助编码器计数器0 

    End Sub

    Private Sub button3_Click(sender As Object, e As EventArgs) Handles button3.Click
        Dim latch_0 As UShort = 0
        dmc_ltc_reset(_CardID, latch_0)
    End Sub

    Private Sub Button11_Click(sender As Object, e As EventArgs) Handles Button11.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡软件复位进行中……")
        Button10.Enabled = False
        Button11.Enabled = False

        Dim dt_start As DateTime
        Dim res As Short
        Dim err As UShort
        dt_start = DateTime.Now
        res = dmc_soft_reset(_CardID)
        If res <> 0 Then
            MessageBox.Show("dmc_soft_reset == " + res.ToString())
            Return
        End If
        While True
            If (DateTime.Now - dt_start).TotalMilliseconds >= 10000.0 Then '设置超时退出，防止死循环
                MessageBox.Show("总线复位失败!")
                Button10.Enabled = True
                Button11.Enabled = True
                Button11.Focus()
                Return
            End If

            res = nmc_get_errcode(_CardID, 2, err)
            If res = 0 Then
                If err = 0 Then '总线复位正常完成
                    Exit While
                End If
            Else
                MessageBox.Show("nmc_get_errcode == " + res.ToString())
                Button10.Enabled = True
                Button11.Enabled = True
                Button11.Focus()
                Return
            End If
            Application.DoEvents()
        End While
        RichTextBox1.AppendText("总线卡软件复位完成,请确认总线状态")
        Button10.Enabled = True
        Button11.Enabled = True
        Button11.Focus()
    End Sub

    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……")
        Button10.Enabled = False
        Button11.Enabled = False

        dmc_board_reset()
        dmc_board_close()

        For i As Integer = 0 To 15 Step 1 '总线卡硬件复位耗时15s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next

        dmc_board_init()
        RichTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态")
        Button10.Enabled = True
        Button11.Enabled = True
        Button10.Focus()
    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click
        nmc_set_axis_enable(_CardID, axis)
    End Sub

    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles Button9.Click
        nmc_set_axis_disable(_CardID, axis)
    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        dmc_hcmp_clear_points(_CardID, 0) '//清除已添加的所有高速位置比较点
        dmc_set_extra_encoder(_CardID, 0, 0)
    End Sub
End Class
