﻿Imports System.Drawing.Drawing2D
Imports System.Threading

Public Class Form1
    Public _CardID As Short = 0
    Public Min_Vel, Max_Vel, Tacc, Tdec, Stop_Vel As Double
    Public AxisX As UShort = 0
    Public AxisY As UShort = 1
    Public AxisZ As UShort = 2
    Public Mode As UShort = 1
    Public crd As UShort = 0

    

    Public _PointsX(100) As Double
    Public _PointsY(100) As Double
    Public _PointsZ(100) As Double

  
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim n As Short
        Dim cardtypes(8) As UInteger
        Dim cardids(8) As UShort
        n = dmc_board_init() '获取卡数量

        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            MsgBox("初始化LTDMC卡失败！", vbOKOnly, "出错")
        Else
            MsgBox("初始化LTDMC卡成功！", vbOKOnly, "OK")
        End If
        dmc_get_CardInfList(n, cardtypes, cardids) '
        _CardID = cardids(0) '
        Timer1.Start() '     
    End Sub

    Private Sub DrawPosImage()

        Dim width As Int32
        Dim height As Int32
        Dim bm As Bitmap
        Dim g As Graphics
        Dim matrix As Matrix
        Dim pen As Pen
        Dim brush As SolidBrush
        Dim p1, p2 As PointF

        
        width = pictureBox1.Width
        height = pictureBox1.Height

        bm = New Bitmap(width, height)
        g = Graphics.FromImage(bm)
        matrix = New Matrix(1, 0, 0, -1, 0, height)
        g.Transform = matrix
        g.SmoothingMode = SmoothingMode.AntiAlias

        '网格绘制
        pen = New Pen(Color.Green)

        g.DrawLine(pen, New Point(width / 3, height / 2), New Point(0, height / 2 - width / 3))
        g.DrawLine(pen, New Point(width / 3, height / 2), New Point(width, height / 2))
        g.DrawLine(pen, New Point(width / 3, height / 2), New Point(width / 3, height))

        '

        brush = New SolidBrush(Color.Black)
        g.ResetTransform()
        g.DrawString("0", Font, brush, width / 3 - 15, height / 2 - 15)

        g.Transform = matrix

        '轨迹绘制
        pen = New Pen(Color.Black)
        For i = 0 To _PointsX.Count - 2
            p1 = ToPointF(_PointsX(i), _PointsY(i), _PointsZ(i))
            p2 = ToPointF(_PointsX(i + 1), _PointsY(i + 1), _PointsZ(i + 1))
            g.DrawLine(pen, p1, p2)
        Next
 
        g.Dispose()
        pictureBox1.Image = bm

    End Sub

    Private Function ToPointF(x As Double, y As Double, z As Double) As PointF
        Dim width As Int32
        Dim height As Int32
        Dim _x, _y As Single
        Dim n As Double

        width = pictureBox1.Width
        height = pictureBox1.Height

        _x = y - x * Math.Cos(Math.PI / 4)
        _y = z - x * Math.Cos(Math.PI / 4)

        n = 1000 / 60
        _x = _x / n + width / 3
        _y = _y / n + height / 2

        Return New PointF(_x, _y)

    End Function



    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim XSpeed, YSpeed, ZSpeed As Double
        Dim XPos, YPos, ZPos As Double
        Dim errcode As Int32
        Dim Axis_State_machine0 As Int32
        Dim Axis_State_machine1 As Int32
        Dim Axis_State_machine2 As Int32

        nmc_get_errcode(_CardID, 2, errcode)
        If (errcode = 0) Then
            TextBox4.Text = "EtherCAT总线正常"
            TextBox4.BackColor = Color.Green
        Else
            TextBox4.Text = "EtherCAT总线出错"
            TextBox4.BackColor = Color.Red
        End If

        nmc_get_axis_state_machine(_CardID, AxisX, Axis_State_machine0)
        Select Case (Axis_State_machine0) ' 读取指定轴状态机

            Case 0 : TextBox1.Text = "轴处于未启动状态"
                TextBox1.BackColor = Color.Red
            Case 1
                TextBox1.Text = "轴处于启动禁止状态"
                TextBox1.BackColor = Color.Red
            Case 2
                TextBox1.Text = "轴处于准备启动状态"
                TextBox1.BackColor = Color.Red
            Case 3
                TextBox1.Text = "轴处于启动状态"
                TextBox1.BackColor = Color.Red
            Case 4
                TextBox1.Text = "轴处于操作使能状态"
                TextBox1.BackColor = Color.Green
            Case 5
                TextBox1.Text = "轴处于停止状态"
                TextBox1.BackColor = Color.Red
            Case 6
                TextBox1.Text = "轴处于错误触发状态"
                TextBox1.BackColor = Color.Red
            Case 7
                TextBox1.Text = "轴处于错误状态"
                TextBox1.BackColor = Color.Red
        End Select

        nmc_get_axis_state_machine(_CardID, AxisY, Axis_State_machine1)
        Select Case (Axis_State_machine1) ' 读取指定轴状态机

            Case 0 : TextBox2.Text = "轴处于未启动状态"
                TextBox2.BackColor = Color.Red

            Case 1
                TextBox2.Text = "轴处于启动禁止状态"
                TextBox2.BackColor = Color.Red

            Case 2
                TextBox2.Text = "轴处于准备启动状态"
                TextBox2.BackColor = Color.Red

            Case 3
                TextBox2.Text = "轴处于启动状态"
                TextBox2.BackColor = Color.Red

            Case 4
                TextBox2.Text = "轴处于操作使能状态"
                TextBox2.BackColor = Color.Green

            Case 5
                TextBox2.Text = "轴处于停止状态"
                TextBox2.BackColor = Color.Red

            Case 6
                TextBox2.Text = "轴处于错误触发状态"
                TextBox2.BackColor = Color.Red

            Case 7
                TextBox2.Text = "轴处于错误状态"
                TextBox2.BackColor = Color.Red

        End Select

        nmc_get_axis_state_machine(_CardID, AxisZ, Axis_State_machine2)
        Select Case (Axis_State_machine2) ' 读取指定轴状态机

            Case 0 : TextBox3.Text = "轴处于未启动状态"
                TextBox3.BackColor = Color.Red

            Case 1
                TextBox3.Text = "轴处于启动禁止状态"
                TextBox3.BackColor = Color.Red

            Case 2
                TextBox3.Text = "轴处于准备启动状态"
                TextBox3.BackColor = Color.Red

            Case 3
                TextBox3.Text = "轴处于启动状态"
                TextBox3.BackColor = Color.Red

            Case 4
                TextBox3.Text = "轴处于操作使能状态"
                TextBox3.BackColor = Color.Green

            Case 5
                TextBox3.Text = "轴处于停止状态"
                TextBox3.BackColor = Color.Red

            Case 6
                TextBox3.Text = "轴处于错误触发状态"
                TextBox3.BackColor = Color.Red

            Case 7
                TextBox3.Text = "轴处于错误状态"
                TextBox3.BackColor = Color.Red

        End Select

        dmc_read_current_speed_unit(_CardID, AxisX, XSpeed) '获取速度
        XActVel.Text = XSpeed.ToString()
        dmc_read_current_speed_unit(_CardID, AxisY, YSpeed) '获取速度
        YActVel.Text = YSpeed.ToString()
        dmc_read_current_speed_unit(_CardID, AxisZ, ZSpeed) '获取速度
        ZActVel.Text = ZSpeed.ToString()

        dmc_get_position_unit(_CardID, AxisX, XPos)
        XActPos.Text = XPos.ToString()
        dmc_get_position_unit(_CardID, AxisY, YPos)
        YActPos.Text = YPos.ToString()
        dmc_get_position_unit(_CardID, AxisZ, ZPos)
        ZActPos.Text = ZPos.ToString()

        Select Case (dmc_conti_get_run_state(_CardID, crd))     '判断连续插补运动状态
            Case 0
                CrdStatus.Text = "运动中"
                CrdStatus.BackColor = Color.Green
            Case 1
                CrdStatus.Text = "暂停中"
                CrdStatus.BackColor = Color.Red
            Case 2
                CrdStatus.Text = "正常停止"
                CrdStatus.BackColor = Color.Red
            Case 3
                CrdStatus.Text = "未启动"
                CrdStatus.BackColor = Color.Red
            Case 4
                CrdStatus.Text = "空闲"
                CrdStatus.BackColor = Color.Red
            Case Else
        End Select

        DrawPosImage()

        'If (_PointsX.Count > 0) Then
        'If (_PointsX(_PointsX.Count - 1) <> XPos And _PointsY(_PointsY.Count - 1) <> YPos And _PointsZ(_PointsZ.Count - 1) <> ZPos) Then
        '_PointsX.Add(XPos)
        '_PointsY.Add(YPos)
        ' _PointsZ.Add(ZPos)
        ' DrawPosImage()
        ' Else
        ' _PointsX.Add(XPos)
        ' _PointsY.Add(YPos)
        ' _PointsZ.Add(ZPos)
        ' End If
        'End If

    End Sub



    Private Sub button7_Click(sender As Object, e As EventArgs) Handles button7.Click

        crd = 0 '   //坐标系号，取值范围：0~2
        AxisX = 0 ' //获取X轴号
        AxisY = 1 ' //获取Y轴号
        AxisZ = 2 ' //获取Z轴号

        Min_Vel = Decimal.ToUInt16(numericUpDown5.Value) ' //获取最小速度
        Max_Vel = Decimal.ToUInt16(numericUpDown6.Value) '//获取最大速度
        Tacc = Decimal.ToUInt16(numericUpDown7.Value) '//获取加速时间
        Tdec = Decimal.ToUInt16(numericUpDown8.Value) '//获取减速时间
        Stop_Vel = Decimal.ToUInt16(numericUpDown9.Value) '//获取停止速度

        '    //设置插补速度曲线     
        dmc_set_vector_profile_unit(_CardID, crd, Min_Vel, Max_Vel, Tacc, Tdec, Stop_Vel)
    End Sub



    Private Sub button3_Click(sender As Object, e As EventArgs) Handles button3.Click
        Dim res As Short
        Dim AxisNum As UShort = 2 ' //插补轴数

        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_line_unit(_CardID, crd, AxisNum, {AxisX, AxisY}, {3000, 3000}, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_line_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button4_Click(sender As Object, e As EventArgs) Handles button4.Click
        Dim res As Short
        Dim AxisNum As UShort = 3 ' //插补轴数

        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 3000)
        dmc_set_position_unit(_CardID, AxisY, 3000)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_line_unit(_CardID, crd, AxisNum, {AxisX, AxisY, AxisZ}, {0, 0, 3000}, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_line_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button12_Click(sender As Object, e As EventArgs) Handles button12.Click
        Dim res As Short
        Dim AxisNum As UShort = 2 ' //插补轴数
        Dim Radius As UShort '  //插补半径

        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        Radius = 1500
        res = dmc_arc_move_radius_unit(_CardID, crd, AxisNum, {AxisX, AxisY}, {0, 3000}, Radius, 1, 0, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_radius_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button13_Click(sender As Object, e As EventArgs) Handles button13.Click
        Dim res As Short
        Dim AxisNum As UShort = 2 ' //插补轴数
        Dim Radius As UShort '  //插补半径
        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        Radius = 1500
        res = dmc_arc_move_radius_unit(_CardID, crd, AxisNum, {AxisX, AxisY}, {0, 3000, 2000}, Radius, 1, 3, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_radius_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button14_Click(sender As Object, e As EventArgs) Handles button14.Click
        Dim res As Short
        Dim AxisX, AxisY, AxisZ, crd As UShort
        AxisX = 0
        AxisY = 1
        AxisZ = 2
        crd = 0
        Dim AxisNum As UShort = 3 ' //插补轴数
        Dim cricle As Int32 = -1 ' //设置空间圆弧，圆弧圈数为0

        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_arc_move_3points_unit(_CardID, crd, AxisNum, {AxisX, AxisY, AxisZ}, {3000, 3000, 0}, {1500, 1500, 1500}, cricle, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_3points_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button15_Click(sender As Object, e As EventArgs) Handles button15.Click
        Dim res As Short
        Dim AxisNum As UShort = 3 ' //插补轴数
        Dim cricle As Int32 = 3 ' //设置空间圆弧，圆弧圈数为0
        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_arc_move_3points_unit(_CardID, crd, AxisNum, {AxisX, AxisY, AxisZ}, {0, 3000, 2000}, {1000, 1000, 1000}, cricle, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_3points_unit == " + res.ToString())
        End If
    End Sub

    

    

    Private Sub button6_Click(sender As Object, e As EventArgs) Handles button6.Click
        Dim res As Short
        Dim AxisNum As UShort = 2 ' //插补轴数

        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_arc_move_center_unit(_CardID, crd, AxisNum, {AxisX, AxisY}, {0, 3000}, {0, 1500}, 1, 0, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button5_Click(sender As Object, e As EventArgs) Handles button5.Click
        Dim AxisNum As UShort = 2 ' //插补轴数
        Dim res As Short
        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_arc_move_center_unit(_CardID, crd, AxisNum, {AxisX, AxisY}, {0, 3000}, {0, 800}, 1, 3, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button1_Click(sender As Object, e As EventArgs) Handles button1.Click
        Dim res As Short
        Dim AxisNum As UShort = 2 ' //插补轴数

        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, -1200)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_arc_move_center_unit(_CardID, crd, AxisNum, {AxisX, AxisY}, {500, 500}, {0, 800}, 0, 2, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button8_Click(sender As Object, e As EventArgs) Handles button8.Click
        Dim res As Short
        Dim AxisNum As UShort = 3 ' //插补轴数

        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_arc_move_center_unit(_CardID, crd, AxisNum, {AxisX, AxisY, AxisZ}, {0, 3000, 3000}, {0, 800, 0}, 1, 3, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button9_Click(sender As Object, e As EventArgs) Handles button9.Click
        Dim AxisNum As UShort = 3 ' //插补轴数
        Dim res As Short
        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, -1200)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_arc_move_center_unit(_CardID, crd, AxisNum, {AxisX, AxisY, AxisZ}, {500, 500, 3000}, {0, 800, 0}, 1, 3, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button10_Click(sender As Object, e As EventArgs) Handles button10.Click
        Dim AxisNum As UShort = 3 ' //插补轴数
        Dim res As Short
        '设置起始位置,例程为了方便观察图形，实际项目不需要调用dmc_set_position_unit
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)
        dmc_set_position_unit(_CardID, AxisZ, 0)

        res = dmc_arc_move_center_unit(_CardID, crd, AxisNum, {AxisX, AxisY, AxisZ}, {0, 3000, 2000}, {0, 1500, 0}, 1, 3, Mode)
        If res <> 0 Then
            MessageBox.Show("dmc_arc_move_center_unit == " + res.ToString())
        End If
    End Sub

    Private Sub Button17_Click(sender As Object, e As EventArgs) Handles Button17.Click
        nmc_set_axis_enable(_CardID, 255) '
    End Sub

    Private Sub Button18_Click(sender As Object, e As EventArgs) Handles Button18.Click
        nmc_set_axis_disable(_CardID, 255) '
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……")
        Button2.Enabled = False
        Button11.Enabled = False

        dmc_board_reset()
        dmc_board_close()

        For i As Integer = 0 To 15 Step 1 '总线卡硬件复位耗时15s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next

        dmc_board_init()
        RichTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态")
        Button2.Enabled = True
        Button11.Enabled = True
        Button2.Focus()
    End Sub

    Private Sub Button11_Click(sender As Object, e As EventArgs) Handles Button11.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡软件复位进行中……")
        Button2.Enabled = False
        Button11.Enabled = False

        Dim dt_start As DateTime
        Dim res As Short
        Dim err As UShort
        dt_start = DateTime.Now
        res = dmc_soft_reset(_CardID)
        If res <> 0 Then
            MessageBox.Show("dmc_soft_reset == " + res.ToString())
            Return
        End If
        While True
            If (DateTime.Now - dt_start).TotalMilliseconds >= 10000.0 Then '设置超时退出，防止死循环
                MessageBox.Show("总线复位失败!")
                Button2.Enabled = True
                Button11.Enabled = True
                Button11.Focus()
                Return
            End If

            res = nmc_get_errcode(_CardID, 2, err)
            If res = 0 Then
                If err = 0 Then '总线复位正常完成
                    Exit While
                End If
            Else
                MessageBox.Show("nmc_get_errcode == " + res.ToString())
                Button2.Enabled = True
                Button11.Enabled = True
                Button11.Focus()
                Return
            End If
            Application.DoEvents()
        End While
        RichTextBox1.AppendText("总线卡软件复位完成,请确认总线状态")
        Button2.Enabled = True
        Button11.Enabled = True
        Button11.Focus()
    End Sub

    Private Sub Button19_Click(sender As Object, e As EventArgs) Handles Button19.Click
        Me.Close()
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        Timer1.Stop()
        dmc_board_close()
    End Sub

    Private Sub Button16_Click(sender As Object, e As EventArgs) Handles Button16.Click

    End Sub
End Class
