﻿Public Class Form1

    Public _CardID As Short = 0
    Public Min_Vel, Max_Vel, Tacc, Tdec, Stop_Vel As Double
    Public AxisX As UShort = 0
    Public AxisY As UShort = 1
    Public AxisZ As UShort = 2
    Public crd As UShort = 0
    Public Mode As UShort = 1

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim n As Short
        Dim cardtypes(8) As UInt32
        Dim cardids(8) As UInt16
        n = dmc_board_init() '获取卡数量

        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            MsgBox("初始化LTDMC卡失败！", vbOKOnly, "出错")
        End If
        dmc_get_CardInfList(n, cardtypes, cardids) '

        _CardID = cardids(0) ' '
        Timer1.Start() '  

    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim XSpeed, YSpeed, ZSpeed As Double
        Dim XPos, YPos, ZPos As Double


        dmc_read_current_speed_unit(_CardID, AxisX, XSpeed)
        XActVel.Text = XSpeed.ToString()
        dmc_read_current_speed_unit(_CardID, AxisY, YSpeed)
        YActVel.Text = YSpeed.ToString()
        dmc_read_current_speed_unit(_CardID, AxisZ, ZSpeed)
        ZActVel.Text = ZSpeed.ToString()

        dmc_get_position_unit(_CardID, AxisX, XPos)
        XActPos.Text = XPos.ToString()
        dmc_get_position_unit(_CardID, AxisY, YPos)
        YActPos.Text = YPos.ToString()
        dmc_get_position_unit(_CardID, AxisZ, ZPos)
        ZActPos.Text = ZPos.ToString()

        textBox4.Text = YSpeed.ToString()
        textBox7.Text = dmc_conti_remain_space(_CardID, crd).ToString() '剩余缓冲区
        textBox8.Text = dmc_conti_read_current_mark(_CardID, crd).ToString() '当前插补号’


        Select Case (dmc_conti_get_run_state(_CardID, crd))     '判断连续插补运动状态
            Case 0
                CrdStatus.Text = "运动中"
            Case 1
                CrdStatus.Text = "暂停中"
            Case 2
                CrdStatus.Text = "正常停止"
            Case 3
                CrdStatus.Text = "未启动"
            Case 4
                CrdStatus.Text = "空闲"
            Case Else
        End Select
        Dim i As UShort
        For i = 0 To 5
            Dim panel As Panel
            For Each control As Control In Me.GroupBox1.Controls
                If TypeOf control Is Panel AndAlso control.Tag.ToString = i.ToString Then
                    panel = control
                    Exit For
                End If
            Next
            If panel IsNot Nothing Then
                If dmc_read_outbit(_CardID, i) = 0 Then
                    panel.BackColor = Color.Green
                Else
                    panel.BackColor = Color.Red
                End If
            End If

        Next
    End Sub

    Private Sub button7_Click(sender As Object, e As EventArgs) Handles button7.Click

        crd = Decimal.ToUInt16(numericUpDown1.Value) '   //坐标系号，取值范围：0~2
        AxisX = Decimal.ToUInt16(numericUpDown2.Value) ' //获取X轴号
        AxisY = Decimal.ToUInt16(numericUpDown3.Value) ' //获取Y轴号
        AxisZ = Decimal.ToUInt16(numericUpDown4.Value) ' //获取Z轴号

        Min_Vel = Decimal.ToUInt16(numericUpDown5.Value) ' //获取最小速度
        Max_Vel = Decimal.ToUInt16(numericUpDown6.Value) '//获取最大速度
        Tacc = Decimal.ToUInt16(numericUpDown7.Value) '//获取加速时间
        Tdec = Decimal.ToUInt16(numericUpDown8.Value) '//获取减速时间
        Stop_Vel = Decimal.ToUInt16(numericUpDown9.Value) '//获取停止速度

        '’ //位置清零
        dmc_set_position_unit(_CardID, AxisX, 0)
        dmc_set_position_unit(_CardID, AxisY, 0)


    End Sub

    Private Sub button1_Click(sender As Object, e As EventArgs) Handles button1.Click
        Dim AxisNum As UShort = 2 ' //插补轴数
        Dim axises() As UShort = {AxisX, AxisY}
        Dim res As Short = 0


        res = dmc_conti_open_list(_CardID, crd, AxisNum, {AxisX, AxisY})
        '    //设置插补速度
        res = dmc_set_vector_profile_unit(_CardID, crd, Min_Vel, Max_Vel, Tacc, Tdec, Stop_Vel)
        '    //
        res = dmc_conti_set_pause_output(_CardID, crd, 2, 32, 0) '//设置暂停连续插补时，OUT5输出低电平，恢复运行时OUT5电平恢复暂停前的电平状态

        '    // ******************第一段轨迹，半圆弧*********************
        res = dmc_conti_delay_outbit_to_start(_CardID, crd, 0, 0, 3000 * Math.PI / 2, 1, 2) '’//相对轨迹起点滞后距离输出，OUT0输出低电平，输出后的电平延时翻转时间为2s
        res = dmc_conti_write_outbit(_CardID, crd, 5, 1, 0) 'OUT5立即输出高电平
        res = dmc_conti_arc_move_3points_unit(_CardID, crd, AxisNum, axises, {0, 6000}, {-3000, 3000}, -1, 0, 0)
        If radioButton2.Checked Then
            res = dmc_conti_clear_io_action(_CardID, crd, 1) '//清除段内 OUT0 未执行完的动作
        End If
        '    //'******************第二段轨迹，直线插补*********************'
        res = dmc_conti_delay_outbit_to_start(_CardID, crd, 3, 0, 1000, 1, 4) ' //相对轨迹起点滞后距离输出，OUT3输出低电平，输出后的电平延时翻转时间为4s
        res = dmc_conti_delay_outbit_to_start(_CardID, crd, 1, 0, 2000, 1, 4) '//相对轨迹起点滞后距离输出，OUT1输出低电平，输出后的电平延时翻转时间为4s
        res = dmc_conti_ahead_outbit_to_stop(_CardID, crd, 2, 0, 1000, 1, 0.5) ' //相对轨迹终点提前距离输出，OUT2输出低电平，输出后的电平延时翻转时间为0.5s   

        res = dmc_conti_line_unit(_CardID, crd, AxisNum, axises, {4000, 0}, 0, 0) '  //直线插补，相对模式
        If radioButton2.Checked Then
            res = dmc_conti_clear_io_action(_CardID, crd, 14)  '//清除段内 OUT1,OUT2,OUT3 未执行完的动作，&H表示十六进制
        End If

        '    //******************第三段轨迹，半圆弧*********************'
        res = dmc_conti_arc_move_center_unit(_CardID, crd, AxisNum, axises, {0, -6000}, {0, -3000}, 0, 0, 0, 0) ' //XY平面圆弧插补，顺时针，相对坐标模式。   此函数是基于圆心圆弧扩展的螺旋线插补运动（可作两轴圆弧插补）

        res = dmc_conti_write_outbit(_CardID, crd, 4, 0, 2) '//OUT4立即输出低电平，输出后的电平延时翻转时间为2s

        '    //******************第四段轨迹，直线插补*********************'
        res = dmc_conti_line_unit(_CardID, crd, AxisNum, axises, {-4000, 0}, 0, 0) '  直线插补，相对模式

        dmc_conti_start_list(_CardID, crd)
        dmc_conti_close_list(_CardID, crd)
    End Sub

    Private Sub button2_Click(sender As Object, e As EventArgs) Handles button2.Click
        If (dmc_conti_get_run_state(_CardID, crd) = 0) Then
            dmc_conti_pause_list(_CardID, crd)
            button2.Text = "继续插补"
        ElseIf (dmc_conti_get_run_state(_CardID, crd) = 1) Then
            dmc_conti_start_list(_CardID, crd)
            button2.Text = "暂停插补"
        End If

    End Sub

    Private Sub button3_Click(sender As Object, e As EventArgs) Handles button3.Click
        dmc_conti_stop_list(_CardID, crd, 0)
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        AxisX = Decimal.ToUInt16(numericUpDown2.Value) ' //获取X轴号
        AxisY = Decimal.ToUInt16(numericUpDown3.Value) ' //获取X轴号
        nmc_set_axis_enable(_CardID, AxisX) '
        nmc_set_axis_enable(_CardID, AxisY) '
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        AxisX = Decimal.ToUInt16(numericUpDown2.Value) ' //获取X轴号
        AxisY = Decimal.ToUInt16(numericUpDown3.Value) ' //获取X轴号
        nmc_set_axis_disable(_CardID, AxisX) '
        nmc_set_axis_disable(_CardID, AxisY) '
    End Sub
End Class
