﻿Imports System.Threading

Public Class Form1
    Public _CardID As Short
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim n As Short
        Dim cardtypes(8) As UInteger
        Dim cardids(8) As UShort
        n = dmc_board_init() '获取卡数量

        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            MsgBox("初始化LTDMC卡失败！", vbOKOnly, "出错")
        Else
            MsgBox("初始化LTDMC卡成功！", vbOKOnly, "OK")
        End If
        dmc_get_CardInfList(n, cardtypes, cardids) '
        _CardID = cardids(0) '
        Timer1.Start() '

    End Sub

    Private Function GetAxis() As UShort
        Dim axis As UShort
        axis = Convert.ToUInt16(numericUpDown1.Value)
        Return axis

    End Function

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim errcode As Int32
        Dim Axis_State_machine As Int32

        nmc_get_errcode(_CardID, 2, errcode)
        If (errcode = 0) Then
            TextBox6.Text = "EtherCAT总线正常"
            TextBox6.BackColor = Color.Green
        Else
            TextBox6.Text = "EtherCAT总线出错"
            TextBox6.BackColor = Color.Red
        End If

        nmc_get_axis_state_machine(_CardID, GetAxis(), Axis_State_machine)
        Select Case (Axis_State_machine) ' 读取指定轴状态机

            Case 0 : TextBox5.Text = "轴处于未启动状态"
                TextBox5.BackColor = Color.Red

            Case 1
                TextBox5.Text = "轴处于启动禁止状态"
                TextBox5.BackColor = Color.Red

            Case 2
                TextBox5.Text = "轴处于准备启动状态"
                TextBox5.BackColor = Color.Red

            Case 3
                TextBox5.Text = "轴处于启动状态"
                TextBox5.BackColor = Color.Red

            Case 4
                TextBox5.Text = "轴处于操作使能状态"
                TextBox5.BackColor = Color.Green

            Case 5
                TextBox5.Text = "轴处于停止状态"
                TextBox5.BackColor = Color.Red

            Case 6
                TextBox5.Text = "轴处于错误触发状态"
                TextBox5.BackColor = Color.Red

            Case 7
                TextBox5.Text = "轴处于错误状态"
                TextBox5.BackColor = Color.Red

        End Select

        Dim speed As Double
        Dim position As Double
        Dim pos As Int32

        dmc_read_current_speed_unit(_CardID, GetAxis(), speed) '
        textBox3.Text = Str(speed) '
        dmc_get_position_unit(_CardID, GetAxis(), position) '
        TextBox1.Text = Str(position) '
        pos = dmc_get_position(_CardID, GetAxis()) '
        TextBox2.Text = Str(pos) '

        If (dmc_check_done(_CardID, GetAxis()) = 0) Then
            TextBox4.Text = "回零中" '
            TextBox4.BackColor = Color.Green
        Else
            TextBox4.Text = "停止中" '
            TextBox4.BackColor = Color.Red
        End If

        Dim IoState As UInt32
        IoState = dmc_axis_io_status(_CardID, GetAxis())
        If ((IoState And 2) = 2) Then '检测正限位信号
            Button6.BackColor = Color.Green
        Else
            Button6.BackColor = Color.Red
        End If

        If ((IoState And 4) = 4) Then '检测负限位信号
            Button8.BackColor = Color.Green
        Else
            Button8.BackColor = Color.Red
        End If

        If ((IoState And 16) = 16) Then '检测原点信号
            Button4.BackColor = Color.Green
        Else
            Button4.BackColor = Color.Red
        End If

    End Sub

    Private Sub button1_Click(sender As Object, e As EventArgs) Handles button1.Click
        Dim returnvalue As Int32
        returnvalue = nmc_set_home_profile(_CardID, GetAxis(), Convert.ToUInt16(TextBox8.Text), Convert.ToDouble(TextBox9.Text), Convert.ToDouble(TextBox10.Text), Convert.ToDouble(TextBox7.Text), Convert.ToDouble(TextBox7.Text), Convert.ToUInt16(TextBox11.Text))

        If (returnvalue = 0) Then
            MessageBox.Show("回零参数配置成功", "注意！", MessageBoxButtons.OK)
        Else
            MessageBox.Show("回零参数配置失败", "注意！", MessageBoxButtons.OK)
        End If

    End Sub

    Private Sub button2_Click(sender As Object, e As EventArgs) Handles button2.Click
        dmc_set_position_unit(_CardID, GetAxis(), 0)
        dmc_set_encoder_unit(_CardID, GetAxis(), 0)
    End Sub

    Private Sub button3_Click(sender As Object, e As EventArgs) Handles button3.Click
        Dim axis As UShort
        axis = GetAxis()
        nmc_set_axis_enable(_CardID, axis)
    End Sub

    Private Sub button5_Click(sender As Object, e As EventArgs) Handles button5.Click
        Dim axis As UShort
        axis = GetAxis()
        nmc_set_axis_disable(_CardID, axis)
    End Sub

    Private Sub button7_Click(sender As Object, e As EventArgs) Handles button7.Click
        Me.Close()
    End Sub


    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles Button9.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……")
        Button10.Enabled = False
        Button9.Enabled = False

        dmc_board_reset()
        dmc_board_close()

        For i As Integer = 0 To 15 Step 1 '总线卡硬件复位耗时15s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next

        dmc_board_init()
        RichTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态")
        Button10.Enabled = True
        Button9.Enabled = True
        Button9.Focus()
    End Sub

    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡软件复位进行中……")
        Button10.Enabled = False
        Button9.Enabled = False

        dmc_soft_reset(_CardID)
        dmc_board_close()

        For i As Integer = 0 To 15 Step 1 '总线卡硬件复位耗时15s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next

        dmc_board_init()
        RichTextBox1.AppendText("总线卡软件复位完成,请确认总线状态")
        Button10.Enabled = True
        Button9.Enabled = True
        Button10.Focus()
    End Sub

    Private Sub Button11_Click(sender As Object, e As EventArgs) Handles Button11.Click
        Dim axis As UShort
        axis = GetAxis()
        nmc_home_move(_CardID, axis)
    End Sub

    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles Button12.Click
        Dim axis As UShort
        axis = GetAxis()
        dmc_stop(_CardID, axis, 1)
    End Sub
End Class
